/*
  Designed by Linjianghua(Xempo) 2005-06,2008-2010, 2012
  Free under LGPL
*/

#include "fsptime.h"
#include "fspdir.h"
#include "jxswitch.h"

#include "infor.h"
#include "init.h"

extern char *OutBuf;

static fsp_dir *ls_dir;

char *dirfmt;

const char *browsMode[BrowsModeCnt]={ "-n", "-d", "-i", "-t", "-p" },
	*_browsMode[BrowsModeCnt]={ "--num", "--dir", "--include", "--total", "--page" };

void showFCU(fsp_dir *dir, BYTE *pStat, BOOL Q_mode)
{/* Q_mode normal is chmode without -m:?, ls [nmb], numb [nmb],  */
int nmb=isZero(dir->Format) ? dir->NumbForZero++ : *(int *)(pStat+FCU_NumPos);
if(*pStat==1 && (Q_mode||(pStat[1]&FSP_MH)==0) ){
	static const char fmt[]="%d";
	int j;
	char buf[58], modebuf[8];
	unsigned int Len;
	getSize(dir, pStat, Len);
	buf[56]=0;
	for(j=1;j<37;j++)buf[j]=0;
	sprintf(buf, fmt, nmb);
	paraExpre(pStat[1],modebuf, "rwhoABGL");
	scopy(buf+17, modebuf);
	sprintf(buf+24, fmt, Len);
	scopy(buf+36,(char *)fspAscTim(FCU_GetDate(pStat) ) );
	for(j=1;j<36;j++)if(buf[j]==0)buf[j]=32;
	msgShow(buf);
	pageMore();
	}
}

inline int n_list(fsp_dir *dir,BYTE *pStat)
{
  int i;
  if((dir->Format&SimpleBase)==0/*&&(dir->mode&6)==0*/)
    for(i=0; i<dir->Num_FCUs_Block; i++,pStat+=dir->Num_FCU_Len )
	showFCU(dir,pStat,False);
  return 1;
}

static int listBase(fsp_dir *dir)
{
if(dir->Format&SimpleBase){
	char buf[200];
	sprintf(buf, " #DataLen=%d  #Cols:%d",dir->DataLen,dir->cols);
	msgShow(buf);
	return 1;
}
return 0;
}

static const char modeChs[]="rwho";
void showPd(fsp_dir *dir, char *pth)
{
  char buff[8], buff2[8], shw[300];
  paraExpre(dir->mode, buff, modeChs);
  paraExpre(dir->Format, buff2, rtl_chr);
  sprintf(shw, dirfmt, pth, buff, buff2, dir->selfnumbs,
	dir->selfdirs,dir->selfsize,fspAscTim(dir->datebuf));
//  len=sprintf(shw, "  %s %s NumStyle:%s Numb=%d ",pth, buff, buff2, dir->selfnumbs);
//	sprintf(shw+len, "[Dir=%d] [sz=%lld]  %s",dir->selfdirs,dir->selfsize,fspAscTim(dir->datebuf));
  msgShow(shw);
  listBase(dir);
}

int d_list(fsp_dir *pdir,fsp_dir *dir)
{
if( (dir->mode&FSP_MH)==0 /*canAccess(dir->mode)*/ ){
  char *pt=pdPathNam(dir,/*dir->lib->CurDir*/ ls_dir, 1);
  int i, dirLoops=1;
  for(i=0; pt[i]; i++)if(pt[i]=='/')dirLoops++;
  if( dirLoops > 0 ){
	char buf[dirLoops*2+1], *tmp;
	memset(buf, 32, dirLoops*2); 
	buf[dirLoops*2]=0;
	tmp=catstr(buf, pt, 0);
	free(pt);
	pt=tmp;
	}
  showPd(dir, pt);
  free(pt);
  pageMore();
}
return 1;
}

int getBM(int *brwVal)
{
int i, msg=0;
pagemore=0;
for(i=0; i<BrowsModeCnt; i++)
    if(brwVal[i])
	switch(i){
	case 3 : msg=7;
		break;
	case 4 : pagemore=True;
		break;
	default : msg|=1<<i;
	}
return msg;
}

void List(fsp_dir *dir0, int n, char **pm, int nCom)
{
int numb;
BOOL isNum;
BYTE *stat;
fsp_dir *dir;
int i, ocn, msg, brwVal[BrowsModeCnt];
memset(brwVal, 0, sizeof(int)*BrowsModeCnt);
ProcOpt optBrows={
	BrowsModeCnt,
	browsMode, _browsMode,
	brwVal,
	0,
	NULL
	};
arglists *lst=procParas(n, pm, &optBrows, NULL);
msg=getBM(brwVal);
i=0;
ocn=lst->argc;
if(ocn==0){
	dir=DirOpen(dir0,NULL); // otherOpen must ++
	goto _jmp_;
	}
while(i<ocn){
  isNum=adjNumb(lst->argv[i]);
  dir=DirOpen(dir0, isNum ? divPath(lst->argv[i],&numb) : lst->argv[i]);
  if(idxdscpt<0x7ffd){ reportBug(); goto _nx_; }
  if(isNum){
    switch(nCom){
    case FSP_numb :
    case FSP_lsnum :
    case FSP_ls : if( (stat=seekFCU(dir,numb, NULL,NUMB_BROW))!=NULL ){
		  showFCU(dir, stat, True);
		  if(nCom==FSP_numb){
			int j, Len=0, tlen=0;
			BYTE *ptr;
			for(j=0; j<dir->DAUC; j++){
			  ptr=pFcuDauPos( dir, stat, j )+sizeof(int);
			  Len=sprintf(OutBuf+Len, "  DAU%d:  prelen=%d\t\tlen=%d\n", j, *(int *)ptr, *(int *)(ptr+sizeof(int)) );
			  tlen+=Len;
			}
			OutBuf[tlen-1]=0;
			msgShow(OutBuf);
		  }
		  free(stat);
		}
		else reportBug();
	break;
    default : fspHB(IsNumb_51, 0);
	showUsage(nCom);
    }
  }
  else _jmp_: switch(nCom){
	case FSP_lsdir : msg=(msg|2)&(2|3);
		goto _skp_;
	case FSP_lsnum : msg=(msg|1)&(1|3);
		goto _skp_;
	case FSP_ls : if((msg&3)==0)msg|=3;
	_skp_:	pdInfo(dir, OutBuf);
		msgShow(OutBuf);
		lock=1;
		ls_dir=dir;
		if(isNormDir(dir))listBase(dir);
		DirFullBrow(dir, msg, n_list, d_list);
		break;
	}
pd_close(dir,1);
_nx_: i++;
}
//if(lst)
argsFree(lst);
}

void pdInfo(fsp_dir *dir,char *buff)
{
if(dir){
char buf[8], buf2[8];
paraExpre(dir->mode,buf, modeChs);
paraExpre(dir->Format,buf2,rtl_chr);
sprintf(buff, dirfmt,
	dir->name, buf, buf2,
	dir->selfnumbs, dir->selfdirs, dir->selfsize,
	fspAscTim(dir->datebuf) );
}
}

/*
#ifndef _NONE_FAST_PAGE_
BOOL SetSpeedPage(fsp_dir *dir,ZeroCache *PageBuff,int dm,int _numb_cur)
{
  int b;
  ZeroCache *zbuf;
  for(b=0;b<PgBufDivLen;b++)
	if(PageBuff[b].pFCT==dm)return False;
  if(dir->lib->zcachesIndex<zcachsiz){
	zbuf=PageBuff+dir->lib->zcachesIndex;
	zbuf->pd_adr=dir? dir->own_adr:20;
	zbuf->pFCT=dm;
	zbuf->NumbForZero=_numb_cur;
	}
return True;
}

int _Numb_Cur;
int _Pg_Cnt, _PgBuf_div;
int speedCache(fsp_dir *dir,BYTE *pStat)
{// heap for catch
int clen=dir->Num_FCUs_Block;
_Pg_Cnt+=clen;
if(_Pg_Cnt>=_PgBuf_div){
	SetSpeedPage(dir,dir->speed_z,dir->pos_numb_FCT,_Numb_Cur);
	_Pg_Cnt=0;
	}
_Numb_Cur+=clen;
return 1;
}
#endif
*/