/*
	Write & edit by Linjianghua(Xempo) 2004-2006,2008-2010,2011-2012, 2014-2015
	Free unde LGPL
*/

#include <sys/stat.h>
#include "calc.def"
#include "normal.h"
#include "fsptime.h"
#include "dirext.h"
#include "dirloop.h"
#include "fspio.h"
#include "fcu.h"
#include "chMT.h"
#include "operafcu.h"
#include "find.h"
#include "copys.h"
#include "rebuild.h"
#include "dlist.h"
#include "export.h"
#include "script.h"
#include "conspace.h"
#include "infor.h"
#include "numbtype.h"
#include "read.h"
#include "write.h"
#include "shellcom.h"
#include "extfunc.h"
#include "stdfun.h"
#include "tds.h"
#include "version.c"

#ifdef	_Simple_Base_
#include "simplebase.h"
#endif

#include "jxswitch.c"

extern TxtDat TDS; // extfunc.c
extern void TxtImpor(fsp_lib *lib1,char *dirnam,int nCmd); // extfunc.c

const _Int confval[8]={0,1,2,3,4,5,6,7};/* GetManu in future */
const char *comchs, newSepa[]="=";

static const char OUTSCR[]="--show", failexe[]="Fail to exec %s";

char **_argv;

void setCfgVal(char *pms)
{
    char **plst, *dat;
    int cmd, n, j;
    dat=GetManu(ConfComs_53); /* get sys-config-commands */
    if(dat){
	n=80;
	plst=setargv(pms, ";,\r\n", &n);
	for(j=0; j<n; j++){
	  cmd=GetComm(plst[j],dat,confval,NULL);
	  if(cmd>-1)Conf_val[cmd]=True;
	  }
	free(dat); free(plst);
	}
}

BOOL setSpace(fsp_lib *send, fsp_lib *curlib)
{
  if(send&&(send->openMode&OpenAlway)==0){
	int n=send->openIdx;
	fspDestroy(send, extDest);
	return putFspAs(curlib, n);
  }
  else return putFspAs(curlib, -1);
}

fsp_lib *openFsp(fsp_lib *send, int n, char **pm, int msg, int ncmd)
{
fsp_lib *lib;
int Root=0,  i=0, N;
static const char  *_OpenMode="--root", 
	*_OpenMode2="--as";
 ProcOpt opt1={	1, NULL, &_OpenMode,	&Root,		0,	NULL	  },
	opt2={	1, NULL, &_OpenMode2,	&i,	0,	NULL	  };
 arglists *alst=procParas(n, pm, &opt1, &opt2);
//  if(alst&& no invObj
 if(alst->argc){
	if(i){
		N=atoi( alst->subarg->argv[0] );
		if(N>=SPACELIMIT){
			fspHB(56, 1);
			goto _jmp_;
		}
	}
	else N=ncmd==FSP_open ? -2 : -1;

	for(i=0; i<alst->argc; i++)
	     if( (lib=fspSpace(alst->argv[i], Root ? msg : msg|OpenLastDir, N )) ){
		if( /*ncmd==FSP_open&&*/N<-1 )setSpace(send, lib);
		send=lib;
		}
	_jmp_: argsFree(alst);
 }
 else { fspHB(I_None_60, 1); showUsage(ncmd); }
 return send;
}

fsp_lib *exeScript(fsp_lib *send, int n, char **pm, int msg, const char *inpPath)
{
	static const char *_msg[2]={ "--nowarn", "--append" };
	int extval[2], i;
	char *pt;
	memset(extval, 0, sizeof(int)*2);
	ProcOpt opt={ 2,	NULL, _msg,	extval,	0, NULL		};
	arglists *alst=procParas(n, pm, &opt, NULL);
	if(alst->argc){
	  for(i=0; i<alst->argc; i++){
	    pt=IsExec(alst->argv[i], pExeNam+2, inpPath);
	    if(pt){
		send=fspScript(send, pt, extval[1] ? 2|msg : msg, inpPath); 
		free(pt);
		}
	    else if(extval[0]==0){ // no --nowarn
		msgShow(alst->argv[i]);
		fspHB(0,1);
		}
	    }
	}
	else { fspHB(I_None_60, 1); showUsage(FSP_exe); }
	argsFree(alst);
	return send;
}

fsp_lib *ExecFile(fsp_lib *send, int argc, char **argv, const char *inpPath)
{
  char *pt, *pm=IsExec(*argv, pExeNam, inpPath);
  if(pm){
    fsp_lib *lib;
    *argv=pm;
    lib=openFsp(send, argc, argv, (3|16|32), FSP_open);
    if(idxdscpt<2/* 0,1 can't open, unknow */ &&
	(pt=strstr(pm, pExeNam[2]))!=NULL&&strcmp(pt,pExeNam[2])==0){
	  idxdscpt=0x7fff;
	  lib=exeScript(send, argc, argv, 1, inpPath);
	}
    free(pm);
    if(lib)return lib;
    else if(idxdscpt<0x7ffd)reportBug();
  }
  else CommNumb=-10;
  return send;
}

static void showWS(fsp_lib *lib)
{
if(lib){
	char ver[16];
	sprintf(ver, ",  Ver%d.%d.%d", lib->ver1, lib->ver2, lib->ver3);
	if(getMsg){
		char buf[400];
		sprintf(buf, "<font color=#080890>WorkSpace</font>: %d, <font color=#08800a>%s</font>%s", lib->openIdx,lib->fname,ver);
		getMsg(buf);
		}
	else printf("\033[31m  WorkSpace: \033[33m%d,  \033[34m%s\n\033[0m%s",lib->openIdx,lib->fname, ver);
	}
}

void pdInfoMore(fsp_dir *dir, char *buf, int s)
{
int L;
char *fmt, *pt;
*buf=0;
if((fmt=GetManu(37))!=NULL){
     char buff[8], modebuf[8];
     pt=pdPathNam(dir,NULL,0);
     paraExpre(dir->mode, modebuf, "rwho");
     paraExpre(dir->Format, buff, rtl_chr);
     L=sprintf(buf, fmt, (pt? pt : rootchs), fspAscTim(dir->datebuf),
	dir->selfsize,dir->Num_FCUs_Block,dir->selfnumbs,
	dir->Dir_FCUs_Block,dir->selfdirs,
	buff, dir->DAUC,
	modebuf, modeToStr(dir->mode));
     if(pt)free(pt);
     if(s){
	const char *ModeScpt=GetManu(38);
	scopy(buf+L, ModeScpt);
	free((void *)ModeScpt);
	}
     free(fmt);
}
if(dir->Format&SimpleBase)
	sprintf(buf+strlen(buf), "  struct alloc:%d", dir->aBSC);
if(s<2)msgShow(buf);
}

int MultSpCmd[ ]={/* follow can use warkspace operate */
	FSP_dir, FSP_select, FSP_read, FSP_output, FSP_getdscpt,
	FSP_insert,FSP_append, FSP_add , FSP_write, FSP_txtload,FSP_ztxtload, FSP_mkdir,
	FSP_del/*del num or dir */, FSP_rm/* rm a num */, FSP_rmdir, FSP_erase, FSP_empty, FSP_ndels,
	FSP_setdscpt, FSP_chmode, FSP_chdate, FSP_find,
	FSP_export,FSP_ren, FSP_rename,FSP_rendir, FSP_cd, FSP_mkstruct, FSP_rescues,
	FSP_ls, FSP_lsnum, FSP_lsdir, FSP_info, FSP_rescue, FSP_rescudir,FSP_ver, FSP_clrcom,
	FSP_remdscpt, FSP_rebuild,FSP_close,0
	},
	sp_disable_cmd[ ]={FSP_export, FSP_info, FSP_rebuild,
		FSP_close, FSP_dircp, FSP_dircps, FSP_copy, 0 };

static const char *fltchs="-F" , *_fltchs="--filter";
static const int cmprInv[3]={0,1,2};
fsp_lib *comRun(fsp_lib *send,char *inpbuf, int env, const char *inpPath)
{
/* env, 0bit : append;  1bit : mkar, no info
*/
  char *pt, **lst, **pm, *extparm;
  const char  *fn;
  static const char ON[]="on", OFF[]="off";
  fsp_lib *curlib=NULL;
  fsp_dir *dir;
  int sel=0, i, j, n=8000, N, ncmd, numb;
  BOOL selrt;
  MAU mau;
  ncmd=GetComm(inpbuf,comchs,kval,&extparm); /* inpbuf[0]==0 , ncmd=EmptyEnter */
  switch(ncmd){
  case FSP_runinginfo : runinginfo=True;
	return send;
  case FSP_add /* add dir1/data */:
  case FSP_write :
  case FSP_insert /* insert.v==write */ : n=3; /* limit */
	break;
  case FSP_append :
  case FSP_calc  :
  case FSP_fspconf :
  case FSP_setcfgval /* set Conf_val */ :
  case FSP_fspinit :
  case FSP_setdscpt : n=2; break;
  }

  errSig_space=False;
  lst=setargv(inpbuf, separaChs, &n);
  if(*inpbuf==0)return send;
  if(ncmd==NotCommand)goto _exeScript_;
  if( n==2 && (j=GetComm(lst[1],"-h,--help",confval,NULL))!=NotCommand)goto _cmdUsage_;
  selrt=getSpace(extparm, &sel, &j);

  if( ncmd>3411 )goto _let;
  if(send==NULL){
	if(selrt)goto _selsp_;
	if( !((ncmd==FSP_rebuild&&n>1) || ncmd>2200) ){
		fspHB(2,1);	goto _exit_;
	}
  }
  if( ((ncmd>2197&&ncmd<2241) || ncmd<2170 )&&
	(n<2&&ncmd>-200 || n<3&&ncmd<-479) ){
_cmdUsage_: showUsage(ncmd);
	goto _exit_;
    }

  if(ncmd==NotCommand){ /* no input EmptyEnter */
_exeScript_: send=ExecFile(send, n, lst, inpPath);
/*      if(send1&&curlib!=send){ fspDestroy(send); send=curlib; } */
	if(CommNumb==-10){
		char buf[160], buf2[80], *dat;
		pt=*lst;
		dat=GetManu(WrongCmd_57);
		sprintf(buf, dat, pt);
		free(dat);
		msgShow(buf);
		if(strlen(pt)>2){
			dat=GetManu(CmdTip_58);
			if(getMsg){
				sprintf(buf2, "<font color=#000090>help %c%c</font>", *pt, pt[1]);
				sprintf(buf, dat, buf2);
				getMsg(buf);
				}
			else {
				sprintf(buf, "\033[7mhelp %c%c\033[0m" , *pt, pt[1]);
				printf(dat, buf);
			}
			free(dat);
		}
		scriptTips(0);
		}
	goto _exit_; 
    }
  else {
	if( selrt ){
_selsp_:	    if(isdone(ncmd,MultSpCmd)==0){
		if(isdone(ncmd,sp_disable_cmd)==0)fspHB(WrongOpera_22, 2|1); // no WarnStyle | no quest
		goto _let;
		}
	    if((sel=selSpace(sel))<0)goto _exit_;
	    curlib=workspace[sel];
	}
	else  _let: curlib=send;
   }
/* FSP_quit(4096) abort prg result, like script error and not make follow, use it.  FSP_exit(11520) norml-exit */
  CommNumb=ncmd;
  n--;  pm=lst+1;
  switch(ncmd){
  case FSP_calc : {	double rt=calc(*pm);
	if(n_CalcErr)msgShow(calcErr());
	else {
		sprintf(OutBuf, "%lf", rt);
		goto _msg_show_;
		}
	}
	break;
  case FSP_echo :
	if(n)
	  if(strcmp(*pm,ON)==0)CommNumb=echo_on;
	  else if(strcmp(*pm,OFF)==0)CommNumb=echo_off;
	break;
  case FSP_close : fspDestroy(curlib, extDest);
	if(curlib==send)send=NULL;
	break;
  case FSP_msgno : pt=GetManu( i=atoi(*pm) );
	if(getMsg){
		char buf[300];
		sprintf(buf,"The number <font color=#000099>%d</font> means <font color=#881212>%s</font>", i, pt);
		getMsg(buf);
		}
	else printf("The number \033[34m%d\033[0m means \033[31m %s\033[0m\n", i, pt);
	break;
  case FSP_impcreat : /* import creat lib in script, if have working lib, import for it,
	otherwise creat lib for script-running */
	 if(send)break;
  case FSP_newspace :
  case FSP_creat : {
#define  mu1  5
 int dir1Val[mu1];
 static const char *dir1chs[mu1]={ "-z", "-t", "-#", "-e", "-f" },
  *_dir1chs[mu1]={"--zero", "--type", "--base" /* smiplebase, would over 1 */,
	"--empty"/* empty for #dir, then can import txtfile to make struct-#dir */, "--force" };
 static const int fmk[mu1]={1, 2, 128, 256, DECT_OVER /* over file no ask when creat rtl-file */};
#define  mu2  6
 int dir2Val[mu2];
 static const char *dir2chs[mu2]={ "-m", "-n", "-d", "-u", "-a", "-s" },
	*_dir2chs[mu2]={ "--mode", "--numpre", "--dirpre", "--unit", "--as", "--size-of-zcache"};

 ProcOpt opt1={	mu1,	dir1chs, _dir1chs,	dir1Val,	0,	NULL	},
	opt2={	mu2,	dir2chs, _dir2chs,	dir2Val,	0,	NULL	};
      un_Int param[pd_param_cnt+1];
      param[pd_param_cnt]=12; /* default size-zcache */
      arglists *alst=fixPdPara(n, pm, &opt1, &opt2, fmk, param);
      if(alst){
        for(i=0; i<alst->argc; i++){
          sel=indexUsedLib(alst->argv[i], inpPath);
          switch(sel){
          case -1 : /* no using */
	if((*param&DECT_OVER)==0 &&
		access(alst->argv[i], 6)==0 && fspHB(36, 2)!='y')goto _out_;
	break;
          case 0 :  fspHB(50, 1); CommNumb=End_Script_Run;
		goto _out_;
          default :	
		if(fspHB(35, 2)!='y')goto _out_;
		if(send&&send->openIdx==sel)send=NULL; /* the creat file exist & have open */
		fspDestroy(workspace[sel], extDest);
	}
          curlib=fspCreat(alst->argv[i], param, False);
          if(curlib){ /* set 0bit freewrite-Mark, can proc 5-spe-numb */
	if((env&2)==0){
	   j=opt2.rtval[4] ? atoi(alst->subarg->argv[4]) : -1;
	   if(j>=SPACELIMIT){
		fspHB(56, 1);
		goto _skp2_;
	    }
	    fspInfo(curlib->CurDir, OutBuf);
	    msgShow(OutBuf);
	    if(j>-1||ncmd==FSP_newspace){
		if(putFspAs(curlib, j )){
			sprintf(OutBuf, curSpace, curlib->openIdx);
			msgShow(OutBuf);
		}
		else {
		  _skp2_:	fspClose(curlib,NULL); break;
		}
	     }
	    else setSpace(send,curlib); // ==False)goto _skp2_;
	}
	send=curlib;
	}
      else if(idxdscpt<0x7ffd)reportBug();
      }
      _out_: argsFree(alst);
      }
#undef  mu1
#undef  mu2
     }
     break;
  case FSP_selspace :
	if(n>0){
	    if(isNumb(*pm)==False){
		fspHB(WrongOpera_22, 1);
		showUsage(FSP_selspace);
		break;
		}
	    i=atoi(*pm);
	    if(i<SPACELIMIT&&workspace[i]){
		send=workspace[i];
		if(i==0)fspHB(50, 1);
		}
	    else { fspHB(52, 1);	break; }
	}
	showWS(send);
	break;
  case FSP_pwd : getcwd(OutBuf,1023);
	goto _msg_show_;
  case FSP_help : 
	if(n>0&&workspace[0]){
		char buf[512], ch;
		pt=(char *)comchs;	i=0;
		j=strlen(pm[0]);
		fndcmd: pt=memstr(pt, 0, pm[0], j,1);
		if(pt){
			if(pt!=comchs && pt[-1]!=',' && pt[-1]!='\n' ){
				pt++;
				goto fndcmd;
				}
			do ch=*pt++;
			while( (buf[i++]=ch)!=0 && ch!=',' && ch!='\n' );
			goto fndcmd;
		}
		while( i>0&& (ch=buf[--i])==',' || ch=='\n'  );
		buf[ i ? i+1 : 0 ]=0;	msgShow(buf);
	}
	else  msgShow(comchs);
	break;
  case FSP_ardir : {
#define  mu1  5
#define  mu2  1
	int Val1[mu1], Val2=0;
	static const char *cmprDir[mu1]={ "-B", "-G", "-L","-r", "-O" }, *_cmprDir[mu1]={ "--bzip2", "--gzip", "--lzma", "--replace", "--only" };
	memset(Val1, 0, sizeof(int)*mu1);
	ProcOpt opt1={	mu1,	cmprDir,  _cmprDir,	Val1,	3,	cmprInv	},
		opt2={	mu2,	&fltchs, &_fltchs,	&Val2,	0,	NULL	};
	arglists *alst=procParas(n, pm, &opt1, &opt2);
	if(alst){ // ==NULL : inv Obj
	    if(alst->argc){
		char *osdir=alst->argv[0];
		for(i=0; i<3; i++)if(Val1[i])break;
		ardir(curlib->CurDir, osdir, (alst->subarg&&alst->subarg->argc>0) ? alst->subarg->argv[0] : NULL,
			i>2 ? FSP_arfile : i+1+FSP_arfile, (Val1[3] ? 1: 0)| (Val1[4] ? 2:0)  );
	      }
	      else { fspHB(I_None_60, 1); showUsage(FSP_ardir); }
	      argsFree(alst);
	}
#undef  mu1
#undef  mu2
	}
	break;
  case FSP_mkar : {
	int Val1[4], Val2=0;
	static const char *cmprChs[4]={ "-B", "-G", "-L","-f" }, *_cmprChs[4]={ "--bzip2", "--gzip", "--lzma", "--force" };
	memset(Val1, 0, sizeof(int)*4);
	ProcOpt opt1={ 4, cmprChs, _cmprChs, Val1, 3,	cmprInv	},
		opt2={ 1, &fltchs, &_fltchs,	&Val2,	0,	NULL	};
	arglists *alst=procParas(n, pm, &opt1, &opt2);
	if(alst){// ==NULL : inv Obj
	  if(alst->argc>1){
	  struct stat fst;
	  char buf[80];
	  const char *cmpr;
	  scopy(buf, "creat -u=2 ");
	  if(Val1[3])strcat(buf, "-f");
	  pt=catstr(buf, alst->argv[0] , 32);
	  curlib=comRun(curlib, pt,  env|2, inpPath);
	  free(pt);
	  if(send==curlib)goto _ex_mkar_;
	  numb=0;
	  for(j=0; j<3&&Val1[j]==0; j++);
	  if(j>2)cmpr=SPC;
	  else cmpr=cmprChs[j];
	  for(i=1; i<alst->argc; i++)
	      if(stat(alst->argv[i], &fst)==0){
		if(S_ISDIR(fst.st_mode)){
			BOOL flt=alst->subarg&&alst->subarg->argc;
			(void)sprintf(buf, "ardir %s %s %s", cmpr, flt ? fltchs : SPC, flt ? alst->subarg->argv[0] : SPC); // wait ...  bzip2, gzip
			}
		else (void)sprintf(buf, "arfile %s %d", cmpr, numb++);
		pt=catstr(buf, alst->argv[i], 32);
		(void)comRun(curlib, pt,  env, inpPath);
		free(pt);
	      }
	  fspClose(curlib, NULL);
	  }
	  else { fspHB(alst->argc>0 ? 61 : I_None_60, 1); showUsage(FSP_mkar); }
	  _ex_mkar_: argsFree(alst);
	}
	}
	break;
  case FSP_divpara :
	if(n>0){
		if(paraSepa!=newSepa)free((void *)paraSepa);
		(void)fmtvalue(*pm, 1);
		paraSepa=strdup(*pm);
		}
	else msgShow(paraSepa);
	break;
  case FSP_path : 
	if(n>0){
	  sel=0;
	  static const char  *_pthchs="--cur";
	  ProcOpt opt={	1, NULL, &_pthchs,	&sel,	0,	NULL	  };
	  arglists *alst=procParas(n, pm, &opt, NULL);
	  if( (i=alst->argc) ){
		pt=alst->argv[0];
		if(*pt=='*' && pt[1]==0)pt=(char *)SPC;
		if(sel==0){ // only current system setting
			mau.buf=pt;  mau.len=strlen(pt);	mau.alen=mau.len+48;
			workspace[0]->sys_Id_done=True;
			num_write((fsp_dir *)(*workspace), PATH_ID/* 2*/, &mau,1);
		}
		_env_path(*_argv, pt, &fspPaths);
	   }
	   argsFree(alst);
	   if(i==0)goto _shw_;
	}
	else _shw_: for(i=0; i<fspPaths.argc; i++)msgShow(fspPaths.argv[i]);
	break;
  case FSP_log  : {
	char buf[48];
	if(n){
		for(i=0;i<n&&strcmp(pm[i],OUTSCR);i++);
		if(i<n)out_scrn_same=True;
		else {
			fspHB(43, 1);
			showUsage(FSP_log);
			goto _log_;
		}
	}
	else _log_: msgShow("Detail see \"fsplus.log\"");
	if((dir=DirOpen((fsp_dir *)*workspace, runLog))==NULL){
		static const un_Int preparm[pd_param_cnt]={  1, 10, 4, 1, 3 };
		scopy(buf, runLog);
		dir=pd_creat((fsp_dir *)*workspace, buf, preparm);
		}
	if(dir){
		j=dir->selfnumbs;	i=0;
		pd_close(dir, 2);
		while(i<j){
			char *lst[2];
			lst[0]=buf;	lst[1]=NULL;
			sprintf(buf,"/Log/%d", i++);
			numSelect(workspace[0], lst, NULL,FSP_log);
		}
		sprintf(buf, " %d records", i);
		msgShow(buf);
		if(logfp){
			fclose(logfp); logfp=NULL;
			}
	}
	out_scrn_same=False;
	}
	break;
  case FSP_mkdir : {
#define  mu1  5
 int dir1Val[mu1];
 static const char *dir1chs[mu1]={ "-z", "-t", "-#", "-e", "-c"},
  *_dir1chs[mu1]={"--zero", "--type", "--base" /* smiplebase, would over 1 */,
	"--empty"/* empty for #dir, then can import txtfile to make struct-#dir */, "--cd" };
 static const int dmk[5]={1, 2, 128, 256, Ch_Dir /* over file no ask when creat rtl-file */};
#define  mu2  4
 int dir2Val[mu2];
 static const char *dir2chs[mu2]={ "-m", "-n", "-d", "-u" },
	*_dir2chs[mu2]={ "--mode", "--numpre", "--dirpre", "--unit" };
 ProcOpt opt1={	mu1,	dir1chs, _dir1chs,	dir1Val,	0,	NULL	},
  opt2={	mu2,	dir2chs, _dir2chs,	dir2Val,	0,	NULL	};
/*	*para=0; Format 
	para[1]=10;	n_stat_FCT   10 
	para[2]=4;	dir_stat_FCT  4 
	para[3]=dau, ignore = 1
	para[4]=1|2;  mode: RW  */
      un_Int param[pd_param_cnt];
      arglists *alst=fixPdPara(n, pm, &opt1, &opt2, dmk, param);
      if(alst){
         for(i=0; i<alst->argc; i++){
	dir=pd_creat(curlib->CurDir, alst->argv[i],param);
	if(dir){
#ifdef			_Simple_Base_
		MakeStruct(curlib,dir);
#endif
		if( *param&Ch_Dir )goto _cd_;
		if(dir->mode&FSP_OEM){
			msgShow(" OEM dir, can write any in this times");
		_cd_:	pd_close(curlib->CurDir, 2);
			curlib->CurDir=dir;
			argsFree(alst);
			goto _dirinfo_;
			}
		pd_close(dir, 0);
		}
	else reportBug();
         }
         argsFree(alst);
       }
     }
      break;
  case FSP_find : Find(send->CurDir, n, pm);
	break;
  case FSP_lsws :
	n=0;
  case FSP_workspace :
 	if(n==0){
		for(i=0;i<SPACELIMIT;i++)
		    if(workspace[i])showWS(workspace[i]);
		break;
	}
  case FSP_open  :  send=openFsp(send, n, pm, (3|4|32), ncmd);
	break;
#ifdef			_Simple_Base_
  case FSP_exestruct : { /* exestruct for script to create struct */
	unsigned int len;
	pt=ReadFile(*pm,&len,True, fspX, &fspPaths);
	if( pt==NULL || curlib->CurDir->DataType ||
	   CreatField(curlib,curlib->CurDir,pt)==False )
		msgShow(DPdef);
	if(pt)free(pt);
	}
	break;
  case FSP_struct : goto ls_stru;
  case FSP_mkstruct  :
	dir=DirOpen(curlib->CurDir,*pm);
	if(isNormDir(dir)&&(dir->Format&SimpleBase)){
	  if(dir->pStruct==0||popMsg("Struct have existed, overwrite it ?\n[Yes/No/Esc]",0, 0, fspX)=='y')
		MakeStruct(curlib,dir);
	  pd_close(dir,1);
	}
	else if(n&&strcmp(*pm,OUTSCR)==0)ls_stru : ListStru(curlib->CurDir);
	     else msgShow(NotSimpleBase);
	break;
#endif

  case FSP_cd : 
	if(ChDire(curlib, *pm, sel)){
		send=curlib;
		errSig_space=True;/* disable showWS */
		_dirinfo_: if(diguei==0||runinginfo){
			pdInfo(curlib->CurDir, OutBuf);
			goto _msg_show_;
			}
		}
	break;
  case FSP_info : showWS(curlib);
	_libinfo_:	if(diguei==0||runinginfo){
			fspInfo(curlib->CurDir, OutBuf);
		_msg_show_: msgShow(OutBuf);
			}
	break;
  case FSP_rescue : NumbUndel(curlib,*pm, 0);
	break;
  case FSP_rescues : for(numb=0;NumbUndel(curlib,*pm,numb);numb++);
	if(getMsg){
		sprintf(OutBuf, "Total <font color=#504040>%d</font> deleted numb be rescue", numb);
		goto _msg_show_;
		}
	else printf("Total \033[7m %d \033[0m deleted numb be rescue\n",numb);
	break;
  case FSP_ren : if(adjNumb(*pm))goto oper_numb;
	      else goto oper_dir;
  case FSP_exe :	send=exeScript(send, n, pm, 1, inpPath);
	break;
  case FSP_ndels :
  case FSP_empty :
  case FSP_erase : 
  case FSP_del  : if(adjNumb(*pm))goto oper_numb;
  case FSP_rendir /* dir-rename */: 
  case FSP_rmdir /* only rm dir */: oper_dir: dOperStat(curlib,pm,ncmd);
	break;
  case FSP_rm /* rm:only rm num */:
  case FSP_rename /* num_rename */: oper_numb: nOperStat(curlib,pm,ncmd);
	break;
  case FSP_rescudir : pdUndel(curlib,*pm);
	break;
  case FSP_cp : NumbCopy(send,pm,extparm);
	break;
  case FSP_dircp : 
  case FSP_dircps : pdCopy(send, n, pm, extparm, ncmd);
	break;
  case FSP_chdate :
  case FSP_chmode : chMT(curlib->CurDir, n, pm, ncmd);
	break;
  case FSP_lsdir :
  case FSP_numb :
  case FSP_lsnum :
  case FSP_ls : List(curlib->CurDir, n, pm, ncmd);
	break;
  case FSP_export : Export(curlib, n, pm, 0);
	break;
  case FSP_import : {
	char *pth;
	if(curlib==NULL)goto _import_;
	ChDire(curlib, pm[1], sel);
	if(idxdscpt>0x7ffd){
	_import_:	pt=(char *)separChr(*pm);
		fn=pt ? catstr(*pm, pt, 0) : catstr(*pm, *pm, '/');
		pth=catstr(fn, RLS, 0);
		free((void *)fn);
		curlib=fspScript(curlib, pth, 1, NULL);
		if(curlib)send=curlib;
		free(pth);
		}
	}
	break;
  case FSP_time : {
	unsigned char buf[8];
	fspTime(0, buf);
	msgShow(fspAscTim(buf));
	}
	break;
  case FSP_clear :
	if(getMsg)getMsg(NULL);
	else {
		printf("\033[2J\033[1;1H");
		goto _dirinfo_;
	}
	break;
  case FSP_clrcom :
	if(getMsg)getMsg(SPC);
	break;
  case FSP_setdscpt : /* can be use extcmd, like setdscpt.o */ 
/*	MAU *snd=MAUalloc(curlib->DAUC);*/
	putMAU(&mau,*pm,_txt/* type */);
	curlib->sys_Id_done=True;
	num_write((fsp_dir *)curlib, SCRIPT_ID/* 1*/, &mau,1);
/*	free(snd);*/
    	break;
  case FSP_getdscpt :
	if( (pt=sysIdRead(curlib,1))!=NULL ){
		msgShow(pt);	free(pt);
		}
	break;
  case FSP_remdscpt : {
	BYTE *unit;
	curlib->sys_Id_done=True;
	if( (unit=seekFCU((fsp_dir *)curlib,SCRIPT_ID/*1*/,NULL,NUMB_READ)) ){
		*unit=0;
		chDirFCU((fsp_dir *)curlib,unit,curlib->FCU_dyw,-1);
		free(unit);
	}
	else reportBug();
	}
	break;
  case FSP_rbconf : 
	if(curlib==NULL)curlib=libhb;
	switch(n){
	case 0 : sprintf(OutBuf, "limited size:%d K, limited persent:%d",curlib->CmprSiz,curlib->cmprPer);
		goto _msg_show_;
	case 2 : curlib->cmprPer=atoi(pm[1]);
	case 1 : curlib->CmprSiz=atoi(*pm);
		curlib->mdf|=1;
	}
	break;
  case FSP_ver : 
	if(getMsg){
		char buf[200];
		sprintf(buf, " &nbsp <font color=#000090>%s</font>\n &nbsp <font color=#900000>%s</font>", fspVer, fspKern);
		getMsg(buf);
		}
	else printf("  \033[31m%s\n  \033[34m%s\033[0m\n",fspVer, fspKern);
		break;
  case FSP_os : 
	if(fork()==0)if(execvp(*pm, pm)!=0){
			sprintf(OutBuf, failexe, *pm);
			goto _msg_show_;
			}
	break;
/*------------------------------------------------------------------*/
  case FSP_fspconf : /*  CONFIG_ID=3 */
  case FSP_fspinit : if(n==0){ // AUTORUN_ID=4
		if((pt=sysIdRead(*workspace, ncmd-FSP_fspconf+CONFIG_ID))!=NULL)
			{ msgShow(pt); free(pt); }
		}
	      else {
		putMAU(&mau,*pm,_sold);
		workspace[0]->sys_Id_done=True;
		num_write((fsp_dir *)(*workspace), ncmd-FSP_fspconf+CONFIG_ID, &mau, 1);
		}
	break;
  case FSP_setcfgval  :	setCfgVal(pm[0]);
	break;
  case FSP_arfile :
  case FSP_insert :
  case FSP_write /* write=insert.v */:
  case FSP_append : /* (curdir) */
  case FSP_add /* add otherdir*/: numInsert(curlib->CurDir,n, pm, extparm, ncmd, env);/* env 0bit: append */
	break;
  case FSP_output : /* (to file:display.txt) */
/*  case FSP_relealzma :  case FSP_releagzip :  case FSP_releabzip2 : */ 
  case FSP_read :
  case FSP_select : numSelect(curlib, pm, extparm, ncmd);
	break;
  case FSP_releafile :
	releasAr(curlib, n, pm);
	break;
  case FSP_releadir :
	Export(curlib, n, pm, 1);
	break;
  case FSP_release : {
	fmtvalue(pm[0], 1);
	curlib=fspOpen(pm[0], FastBuf);
	if(curlib){
		Export(curlib, n-1, pm+1, 2);
		fspClose(curlib, NULL);
		}
	}
	break;
/*------------------------------------------------------------------*/
  case FSP_ztxtload :
  case FSP_txtload : memset(&TDS,0,sizeof(TxtDat));
		CreatTD(&TDS,*pm, 1|4, fspX, &fspPaths);
  case FSP_ztxtimpor :
  case FSP_txtimpor : TxtImpor(curlib,pm[1],ncmd);
	break;
  case FSP_rebuild : {
	static const char *_rb[2]={ "--verbose", "--fit" };
	int extval[2];
	memset(extval, 0, sizeof(int)*2);
	ProcOpt opt={ 2, NULL, _rb, extval, 0, NULL	};
	arglists  *alst=procParas(n, pm, &opt, NULL);
	N=(extval[0] ? ShowTips : 0)|(extval[1] ? OptiFit : 0);
	j=0;	i=0;
	if(alst->argc==0){
		if(curlib)goto _rebuild_;
		else { fspHB(I_None_60, 1); showUsage(FSP_rebuild); }
		}
	else {
	   while(i<alst->argc){
_rebuild_:	curlib=fspRebuild(curlib, alst->argc>0 ? alst->argv[i] : NULL, N );
		if( curlib  ){ j=1; send=curlib; }
		i++;
	      }
	}
	argsFree(alst);
	if(j)goto _libinfo_;	
	}
	break;
  case FSP_closeall :
	for(i=1;i<SPACELIMIT;i++)if(workspace[i])fspDestroy(workspace[i], extDest);
	send=NULL;	break;
  case FSP_readme : fspHB(Readme_31, 0);
	break;
  case FSP_copyright :
	if(getMsg){
		sprintf(OutBuf, " &nbsp <font color=#000080> %s </font>", copyRight);
		goto _msg_show_;
		}
	else printf(" \033[37;44;1m %s \033[0m \n", copyRight);
	break;
  case FSP_dir : {
	sel=0;
	static const char  *chs="-d", *_chs="--detail";
	ProcOpt opt={1,	&chs, &_chs,	&sel,	0, NULL	};
	arglists *alst=procParas(n, pm, &opt, NULL);
	i=0;
	if(alst->argc==0)pdInfoMore(curlib->CurDir, OutBuf, sel&0x7fff);
	else while( i<alst->argc ){
		pt=alst->argv[i];
		dir=DirOpen(curlib->CurDir,pt);
		if(idxdscpt>0x7ffd){
			pdInfoMore(dir, OutBuf, sel&0x7fff);
			pd_close(dir, 2);
		}
		else reportBug();
	     i++;
	     }
	argsFree(alst);
	}
  }// switch(ncmd)  end

_exit_:  if(lst)free(lst);
  if(sel>0&&isdone(ncmd,sp_disable_cmd)==False&&curlib&&curlib!=send){
     if(errSig_space==False)showWS(curlib);
  }
  return send;
}
