/*
	Write by xempo
	Free under LGPL
*/

#include "filesan.h"

#ifndef  SEARCH_MODIFY
#define SEARCH_MODIFY

#include <sys/time.h>
#include <qtabwidget.h>
#include "pluzone.h"
#include "fileatt.h"
#include "../fsplus/source/extfunc/tds.h"
#include "xfunc.h"
#include "../libnorm/listopera.h"

#define SCAN_CS			2
#define SCAN_TDS			4

class  QGroupBox;
class  QCheckBox;
class  QDateTimeEdit;
class  QFontMetrics;
class  Combo;
class  QPainter;

struct findparams {
const char *pth, *filters, *kwFind, *kwRepl;
int uId, gId; // init -1
long long sizelmt0, sizelmt1; // init -1
uint timelmt0, timelmt1; // 0
};

struct sm_params {
char *fnam;
ListOptions opt;
bool mdf;
};

class SearchModify : public QMainWindow
{
moc_Object
public:
   SearchModify( QWidget* parent);
   ~SearchModify();
   void exe();
   void findStart(int cmd);

   void popRightMenu(LVItem *); // use in ListContent

   ListContent *vList() const 
	{ return _vList; }

   FastBlock *getFSels() { return &fsels; }

   Combo *getPathCombo() const
	{ return pathCombo; }

   void setSmThread(int th){ smThread=th; }

   int getSmThread() const
 	{ return smThread; }

   void chFattrib(struct fAttribRslt *);

   Filesan *getFilesor() const
	{ return filesor; }

   StatusPanel *stBar() const
	{ return sbar; }

   void setEvent(){ cpEvent=true; }

   void grapDemo(bool erase);
   void run();
   bool fltNull();
   bool adjFltNull(bool b);

protected :
bool event(QEvent *e);
virtual void customEvent(QCustomEvent *e);

private:
   void quitThread();
   void setResult();
   void setRunStatus();
   void resetList(bool res);
   void adjListView(bool res);
   void insertList(struct sm_params *pms, int M);
   void addList(const char *chs);
   void doSM(const char *chs, struct stat64 &st, int Msg, const struct findparams *fndpm, FastBlock *bak);
   void adjFindMode();
   bool lmtStat(struct stat64 &src_st, const struct findparams *fndpm);

    QTabWidget *tabs;
    QWidget *listSet;
    ListContent *optList;
    QPushButton *upBtn, *downBtn, *orgStyleBtn;
    const QPixmap **freqPix;

    QGroupBox *pathGroup, *fileGroup, *keywordGroup, *timeGroup;
    QCheckBox* subChk, *pathCaseChk, *fuser, *fgroup,
	*kwWordChk, *resetChk,
	*chk[3], *tmChk[3];

    Combo *pathCombo,
    * keywordCombo, * replaceCombo,
    *fsizeCombo0,     *fsizeCombo1,
    *userCombo,    *groupCombo,
    *dtfmtCombo, *grapCombo,
    *filterCombo;

    QComboBox *pathCodeCombo, *kwCodecCombo;

    ListContent *_vList;

   QDateTimeEdit *earlyDateTime, *lateDateTime;
   struct sm_params *sm_pms;
   int sm_preCnt, sm_cnt, shwCnt;

   QLabel *kwfind, *kwrepl,
	*dtfmtLab, *lmtSiz,
	*codeLab1, *codeLab2;

    QCheckBox *binChk, *kwCaseChk, *bakupChk, *TDSChk,
	*grapShowChk;

    QString pathStr, filterStr,
	kwFind, kwRepl;
    QStringList smLog;

    QToolBar *tb;
    QFontMetrics *fmtr;
    FastBlock  fsels, operalst, dns;
    int *_Params;
    const char **_smwdg_, **timChkChs, **sizChkChs, *p_renam;
    char *smColOpt, smUseCols[colOptCnt], colsbak[colOptCnt*2];
//    struct timeval tmcn;
    bool firstLoop, sortA, runSearch, operaListTag,
	listSetMsg, waitMsg, cpEvent, filterNull, startMsg, deleting;
    int pathCodec, kwCodec, smTag, smCmd, tms,
	orgw,	orgb,
	wheel_SM, smThread, // >0 is pthread_runing: 1 search; 2 notify;
	// -1 during-quitThread, -2 close, -3 quitprg, -4 end-sm
	orgDtfmtIdx, org_grapShow,
	grapSizLmt, org_SizLmt,
	fntSz, fntBPos, pixBPos;
    Filesan *filesor;
    StatusPanel *sbar;
    QPainter *painter;

    QAction *findAct, *replAct, *operaListAct, *smLogListAct,
	*searchCutAct, *stopAct, *saveResultAct,
	*selAsSrcAct,  *selAddAct,
	*proEditAct, *sImageAct, *fspConAct,
	*cp2dirAct, *mv2dirAct, *dirSumAct, *attribAct, *renAct,
	*delAct,  *vdelAct,   *selAllAct;
   TxtDat *pfdat;
   const char *getchs(const QString &pathChs, int code);
   void removeItem(LVItem *it, int idx);
   struct findparams *SMpms;

   void smRecorde(const char *txt);
   int smBackup(const char *fname, FastBlock *bakup);
   void chSelect();
   void logEnabled(const QString &s);
   int acceDir(int Msg, const char *fdirnam,   const struct findparams *pms);
   int SMfile(const char *fname, const char *chkstr, const char *repstr,int msg, FastBlock *bakup);
   void codecComb(QComboBox *combo, int c);
   QTextCodec *curCodec();
};

extern const char slot_find[], slot_find2[], slot_stop[];
extern const char search_modify[], smfilter[];

extern  char *smColOpt, smUseCols[colOptCnt];
extern QStringList smLogList;

#endif
