/*
    林江华编写，2010-2，2015
    Free under LGPL 2-2010
    email :  xempo@189.cn
*/
#include <fcntl.h>
#include <sys/errno.h>
#include <qdatetime.h>
#include <qmenubar.h>
#include <qpixmap.h>
#include <qcursor.h>
#include <qpainter.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qtoolbutton.h>
#include "filesan.h"
#include "xfunc.h"
#include "helpwdg.h"
#include "fspdir.h"
#include "proedit.h"
#include "../rtdata/en/target/filesor.h"
#include "../rtdata/en/target/init.h"
#include "fileatt.h"
#include "genset.h"
#include "stocks.h"
#include "simpleimage.h"
#include "dirloop.h"
#include "copypanel.h"
#include "searchmodify.h"
#include "fspcon.h"
#include "conspace.h"
#include "init.h"
#include "extfunc.h"

#include "basewidget.cpp"

#define dirNoSortMenuPos  6

static const char slot_copyright[]=SLOT(copyright()),	slot_about[]=SLOT(about()),
	slot_mous[]=SLOT(mousClk()),
	sig_mous[]=SIGNAL(mouseButtonPressed(int, QIconViewItem *, const QPoint &));

const char pluzone[]="pluzone", _Spc[]="",
	clickSig[]=SIGNAL(clicked()),
	slot_addtag[]=SLOT(addTag()), ShowSig[]=SIGNAL(aboutToShow()),
	slot_quitPrg[]=SLOT(closeAllWindows());

const char **_filesor_=(const char **)pluzone, // for init seg, give it space
 **colName, **cpListCols, *p_dtfmt;

char *colOptRslt, useCols[colOptCnt];

QPtrList <Filesan> filesors;

extern int langIdx;

FastBlock  _List[ListCount];

void Filesan::fsKillTimer()
{
if(prgTmId&&cp_tm==0){
	killTimer(prgTmId);
	prgTmId=0;
}
}

QScrollView *Filesan::currentView()
{
return _filelist ? (QScrollView *)_filelist : (QScrollView *)_iconview;
}

char *Filesan::listFullPath(LVItem *it)
{
return it ? catstr(dirNam, it->fnam , '/') : NULL;
}

char *Filesan::viewFullPath(IVItem *ico)
{
return ico ? catstr(dirNam, ico->fnam, '/') : NULL;
}

char *Filesan::currentItemPath()
{
return _filelist ? listFullPath((LVItem *)_filelist->currentItem()) : viewFullPath((IVItem *)_iconview->currentItem()) ;
}

void Filesan::refreshList(const char *fmt)
{
p_dtfmt=fmt;
if(_filelist){
	int i, tmp=_filelist->columns();
	_filelist->setUpdatesEnabled(false);
	for(i=1; i<tmp; i++)_filelist->removeColumn(1);
	creatFileList(mainSplit, _filelist, colOptRslt, useCols, 1);
	setCWD(dirNam, RESHOW_LIST, NULL);
	_filelist->setUpdatesEnabled(true);
	}
}

void Filesan::setProgFonts(const QString &fn, const char *sz, bool bold, bool italic, bool underline)
{
	QFont fnt(fn, atoi(sz), bold ? QFont::Bold : QFont::Normal, italic);
	fnt.setUnderline(underline);
	getBaseHeight(fnt);
	setFont(fnt);
	setFonts(fnt);
	SavFont(font(), progFontId);
}

char *Filesan::curSelItemPath()
{
return _filelist ? listFullPath(_filelist->curSelItem()) : viewFullPath(_iconview->curSelIco());
}

#define	getItemText(ptr)	(ptr? (_filelist? ((const LVItem *)ptr)->fnam : ((const IVItem *)ptr)->fnam) : _Spc)

char *Filesan::itemFullPath(const void *ptr)
{
return catstr( dirNam, getItemText(ptr), ROOT_CH);
}

bool Filesan::isViewOpera()
{
if(modul==NO_MULT_PANEL||currentView()->hasFocus())return true;
if(treeview->hasFocus()==false){
	if(vDirCnt+vFileCnt<1)return false;
	return _filelist ? _filelist->isSelected(_filelist->currentItem()) : ( _iconview->currentItem() ? _iconview->currentItem()->isSelected() : false);
	}
return false;
}

QToolButton *Filesan::creatPB(QWidget *wdg, int Img, const char *tips, QObject *obj,
	const char *slot, bool togg, bool on, int key)
{
QToolButton *Btn=new QToolButton(wdg);
Btn->setIconSet(*pixmapLoad(Img));
Btn->setTextLabel(QString::fromUtf8(tips),true);
Btn->setAutoRaise(true);
if(key)Btn->setAccel(QKeySequence(key));
if(togg){
	Btn->setToggleButton(true);
	Btn->setOn(on);
}
connect( Btn, clickSig,  obj, slot);
return Btn;
}

static const char slot_dbclick[]=SLOT(dbclick()), sig_dbclick[]=SIGNAL(doubleClicked(QListViewItem *));
const char  sig_chsel[]=SIGNAL(selectionChanged()), slot_chsel[]=SLOT(chSel()),
	slot_vEnter[]=SLOT(enter()),
	sig_lCurCh[]=SIGNAL(currentChanged(QListViewItem*)),
	slot_lCurCh[]=SLOT(lCurCh(QListViewItem*));
const char *_filelistSig[ ini_slot_cnt ]={
	sig_lCurCh,
	sig_dbclick,
	sig_chsel,
	sig_enter,
	sig_doRen
	};
const char *_filelist_slots[ ini_slot_cnt ]={
	slot_lCurCh,
	slot_dbclick,
	slot_chsel,
	slot_vEnter,
	slot_doRen
	};

const char slot_iCurCh[]=SLOT(chIco()),
	sig_iCurCh[]=SIGNAL(currentChanged(QIconViewItem *));
const char *_iconviewSig[ _iconview_slot_cnt ]={
	SIGNAL(doubleClicked(QIconViewItem *)),
	SIGNAL(itemRenamed(QIconViewItem *)),
	sig_chsel, // 次序 chsel => chcur => mouse_clk
	sig_iCurCh,
	SIGNAL(returnPressed(QIconViewItem *)),
	sig_mous,
	SIGNAL(dropped(QDropEvent *, const QValueList<QIconDragItem> &))
	};

const char *_iconview_slots[ _iconview_slot_cnt ]={ slot_dbclick,
	slot_doRen,
	slot_chsel,
	slot_iCurCh,
	slot_vEnter,
	slot_mous,
	SLOT(iconviewDrop(QDropEvent*))
	};


QScrollView *creatFileList(QWidget *wdg, void  *ptr, const char *cols, char *use_cols, int sw)
// sw : 0 bit is new; 1bit is sm_wdg
{
#define  is_freshMsg  (sw&1)
#define  is_smWdg    (sw&2)
int t=0, i=0;
static const char sortChs[]=SLOT(Sort(int));
const char *pRc;
QWidget *pwdg=wdg->topLevelWidget();
ListContent *vlst;
if(is_freshMsg)vlst=(ListContent *)ptr;
else {
  vlst=new ListContent(wdg, (const char *)ptr, is_smWdg ? T_SearchList : T_FileList,
	is_smWdg ? ((SearchModify *)pwdg)->getFilesor() : (Filesan *)pwdg);
  vlst->setSorting(-1);
  vlst->setSelectionMode(QListView::Extended);
// vlst->setDefaultRenameAction(QListView::Accept);
  vlst->addColumn( QString::fromUtf8(ColName) );
  if(is_smWdg)
	vlst->addColumn(QString::fromUtf8(ColPath));
}
for(pRc=cols+colOptCnt; i<colOptCnt; i++)
	if(pRc[i]){
		use_cols[t++]=cols[i];
		vlst->addColumn( QString::fromUtf8(colName[ cols[i]-1 ]) );
		if(cols[i]==1)vlst->setColumnAlignment(is_smWdg ? t+1 : t, Qt::AlignRight);
	}
use_cols[t]=0;
setListColWidth(vlst, is_smWdg ? SM_ColumnWidthsId : ColumnWidthsId);
if(!is_freshMsg){
	for(i=0; i<ini_slot_cnt; i++)pwdg->connect(vlst, _filelistSig[i], pwdg, _filelist_slots[i] );
// connect(vlst, sig_chcur, this, SLOT(test()) );  次序不同iconview，先currentChange
	pwdg->connect(vlst->header(), SIGNAL(clicked(int)), pwdg, sortChs );
}
vlst->setPaletteBackgroundColor(0xe6e8e8);
return vlst;
}

QScrollView *Filesan::creatIconView(QWidget *wdg, int sw)
{
int i;
ImageFileView *vIco=new ImageFileView(wdg);
for(i=0; i<_iconview_slot_cnt; i++)connect(vIco, _iconviewSig[i], this, _iconview_slots[i] );
// no use selectChange, because 次序 chsel => chcur => mouse_clk
if(sw==0){ _filelist=NULL; _iconview=vIco; }
vIco->setPaletteBackgroundColor(0xe6e6e6);
return vIco;
}

const char  slot_asSrc[]=SLOT( asSrc() ),  slot_addSrc[]=SLOT( addSrc() ),
 slot_ren[]=SLOT( toggRen() ), slot_move[]=SLOT( move() ), 
 slot_dup[]=SLOT(fdup()), slot_creatSym[]=SLOT( creatSymlnk()),
 slot_attrib[]=SLOT(attrib()), slot_newDir[]=SLOT(newDir()),
 slot_del[]=SLOT(del()), slot_selall[]=SLOT(selall()),
 slot_loadSM[]=SLOT(popSM()), slot_multPanel[]=SLOT(multPanel()),
 slot_pluzone[]=SLOT(runPluzone()), slot_open[]=SLOT(open()),
 slot_list[]=SLOT(chList()), slot_imgbrw[]=SLOT(imageBrow()),
 slot_onlyfile[]=SLOT(onlyfile()),
 slot_dsum[]=SLOT(dirsum()), slot_cp2dir[]=SLOT(cp2dir()), slot_mv2dir[]=SLOT(mv2dir());

static const char _engn[4][6]={ "bzip2", "gzip", "lzma", "zip" };
void Filesan::popRightMenu(void *it, bool vw)
{
ActMenu mpop(this);
QPopupMenu openMenu(this), mountLoop(this),
	fspArEng(this), arEng(this);
int  j, cnt, tag, mode=CurDirMode;
mpop.setFont(font());
if(!vw){
	struct stat64 st;
	char *ptr, *pt=strdup(dirNam);
	if( ptr=strrchr(pt, '/') ){
		if(pt!=ptr)*ptr=0;
		else *(++ptr)=0;
		stat64(pt, &st);
		mode&=operaState(&st);
		if((mode&mode_r)==0){
			free(pt);
			if(it)goto _ex_;
			else return;
			}
		}
	free(pt);
}
tag=getItemAttrib(vw, true);
if( it && selectDoneAct->isEnabled() ){
	selectDoneAct->addTo(&mpop);
	selectAddAct->addTo(&mpop);
	mpop.insertSeparator();
}
cnt=selAsSrc.count();
if( mode&mode_x ){
  bool wbool, w=(mode&mode_w), B=(tag&mode_w) &&w;
  if( wbool=(cnt>0 && (w||(CurDirMode&mode_w)) ) ){
	copyAct->addTo(&mpop);
	fdupAct->addTo(&mpop);
	moveAct->addTo(&mpop);
	linkAct->addTo(&mpop);

	genArchAct->addTo(&mpop);
	for(j=0; j<4;j++)arEng.insertItem( _engn[j], j );
	mpop.insertItem(QString::fromUtf8(compressSub), &arEng);
	connect(&arEng, sigactIdx, this, SLOT(cmprs(int)) );

	fspArchAct->addTo(&mpop);
	for(j=0; j<3;j++)fspArEng.insertItem( _engn[j], j );
	mpop.insertItem(QString::fromUtf8(fspArChs), &fspArEng);
	connect(&fspArEng, sigactIdx, this, SLOT(fspAr(int)) );

	for(j=0; j<cnt; j++)if(namefilters(selAsSrc.lstIndex(j), archNam, 1)==0)goto _jmp_;
	mpop.insertItem(*pixmapLoad(decompressImg), QString::fromUtf8(decompressChs), this, SLOT(dcmpr()), 0);
_jmp_:	mpop.insertSeparator();
	}
//  deleteAct->setEnabled( it && B ); // test btn_stat
  if( it ){
	const char *fn=vw ? itemFullPath(it) : dirNam;
	if(vw)mpop.insertMenu(-1, fexec, this, slot_open,  0);
	openMenu.setFont(font());
	if(creatOpenMenu(openMenu, this, fn))
		mpop.insertItem(QString::fromUtf8(opensChs), &openMenu);
	if(vw){
		free((void *)fn);
		if((tag&mode_dir)==0){
			if(tag&mode_r)proEdit2Act->addTo(&mpop);
			}
		if(modul==_FSPLUS){
			mpop.insertSeparator();
			if(fspTag)mpop.insertMenu(fsplusImg, "Open fsplus ...", treeview, SLOT(openFsp()), 0);
			else {
				if( tag&mode_dir ){
					if(tag&mode_w)mpop.insertMenu(importImg, "Fsplus import", this, SLOT(import()), 0);
				}
				else mpop.insertMenu(fspScriptImg, "Fsplus script", this, SLOT(fspexe()), 0);
			}
			mpop.insertSeparator();
		}
	}
	operaMenu->setItemEnabled( renId , B&&modul!=_PLACE );
	if(modul==_FASTTAGS|| (B&&(modul==_OSROOT||vw)) || (((LVItem *)it)->parent()&&modul==_PLACE) ){
		mpop.insertMenu(-1, renChs, this, slot_ren, Key_F2 );
		mpop.insertSeparator();
		if(modul==_FASTTAGS&&vw==false && ((LVItem *)it)->parent()==treeview->firstChild())
			mpop.insertMenu( tagRemImg, tagRemChs, this, SLOT(deleteTag()), 0 );
		else deleteAct->addTo(&mpop);
		}
	if(B&&modul!=_PLACE)mpop.insertSeparator();
   }
   if(CurDirMode&mode_w)mpop.insertItem(*pixmapLoad(newImg), QString::fromUtf8(newChs), newMenu);
   if(selAllAct->isEnabled() )selAllAct->addTo(&mpop);
  }
if(u_id==0){
	switch(modul){
	case _PLACE : 
		if(vw==false){
		    mpop.insertItem(QString::fromUtf8(remount), treeview, SLOT(remnt()), 0);
		    mpop.insertItem(QString::fromUtf8(freshmount), treeview, SLOT(trymnt()), 0);
		    if(dirNam[1] && it && ((LVItem *)it)->parent()==NULL){
			mpop.insertSeparator();
			mpop.insertItem(QString::fromUtf8(umount), treeview, SLOT(unmount()), 0);
		    }
		}
//		break;
	case _FASTTAGS :
	case _OSROOT : if(cnt && it && (getItemAttrib(vw, false)&mode_dir)){
		mountLoop.setFont(font());
		mpop.insertSeparator();
		mountLoop.insertItem("iso", treeview, SLOT(mntiso()), 0);
		mountLoop.insertItem("squashfs", treeview, SLOT(mntsquashfs()), 0);
		mpop.insertItem(*pixmapLoad(mountLoopImg), QString::fromUtf8(mntloop), &mountLoop);
		}
	}
}
if(it){
	if(mpop.count())mpop.insertSeparator();
_ex_:	if((tag&mode_dir)&& (tag&mode_x)){
	    dirSumAct->addTo(&mpop);
	    if((tag&mode_w)  && cnt ){
		cp2dirAct->addTo(&mpop);
		mv2dirAct->addTo(&mpop);
		}
	}
	propertiesAct->addTo(&mpop);
}
if(_filelist==NULL&& (vDirCnt+vFileCnt) ){
	mpop.insertSeparator();
	mpop.insertMenu(-1, relinage, this, SLOT(freshIV()), ALT+Key_F8);
	}
mpop.exec( QCursor::pos() );
}

void Filesan::busiedCursor()
{
  if( cursorTimes++<1 )QApplication::setOverrideCursor( Qt::WaitCursor );
  if(cursorTimes<1)cursorTimes=1;
}

void Filesan::normalCursor()
{
  if( --cursorTimes < 1)QApplication::restoreOverrideCursor();
}

void Filesan::creatMultPanel(QRect *r)
{
if(modul!=NO_MULT_PANEL){
  multfunPanel=new QSplitter(Vertical, one);
  if(r && r->width()>2 )multfunPanel->setGeometry( *r );
  else if(setWdgSize( multfunPanel, fspRoot, treeSizeId)==false)multfunPanel->setGeometry(0,0,width()/3, height() );
  dirBW=new BaseWidget(multfunPanel, this);
  treeview=new TreeView(dirBW, 0, this);
  one->setResizeMode( multfunPanel, QSplitter::KeepSize);
  if(!pms_panelRight)one->moveToFirst(multfunPanel);
  fastTagsBtn=creatPB(dirBW, fastTagsImg, fastTagsChs,treeview, SLOT(fastTags()), true, modul==_FASTTAGS);
  placeBtn=creatPB(dirBW, placeImg, placeChs, treeview, SLOT(place()), true, modul==_PLACE);
  fsplusBtn=creatPB(dirBW, fsplusImg, "FreeStar+", treeview, SLOT(fsplus()), true, modul==_FSPLUS, CTRL+Key_F8);
  for(int i=0; i<lineCnt; i++){
	lines[i]=new QFrame(dirBW,NULL);
	lines[i]->setFrameStyle( QFrame::HLine | QFrame::Sunken );
	}
  treeDescendBtn=creatPB(dirBW, treeDescendImg, tvDescend, treeview, SLOT(treeDescend()), true, pms_treeDescend<0);
  panelRightBtn=creatPB(dirBW, panelRightImg, panelRight, this, SLOT(multPR()), true, pms_panelRight, Key_F8);
  toolPanelBtn=creatPB(dirBW, toolLeftImg, toolPanelChs, this, SLOT(toolPanelLeft()), true, pms_toolPanelLeft, Key_F7);
  multPanelBtn=creatPB(dirBW, multPanelImg, multPanelChs, this, slot_multPanel, true, true,CTRL+Key_F9);
  listBtn=creatPB(dirBW, filelistImg, listChs, this, slot_list, true, _filelist);
  browImageBtn=creatPB(dirBW, grapBrowImg, browImageChs, this, slot_imgbrw, true, brwImg);
  onlyFileBtn=creatPB(dirBW, onlyFileImg, onlyFileChs, this, slot_onlyfile, true, pms_onlyFile);
  }
}

Filesan::Filesan(QWidget *parent, int fspInit) :
	QMainWindow(parent, pluzone, WType_TopLevel|Qt::WDestructiveClose ) ,
	fsels(__AppenAlone),
	u_id(uId),	g_id(gId),	init_rt(fspInit),
	navBtn(0),	disktime(0),
	Filter(NULL),	dirNam(NULL),
	prgTmId(0),	wheel_tm(0),
	oldName(NULL), cursorTimes(0), tagCount(0),
	itemDel(0),  iconDel(0),	showTm(false), 
	notifyFP(NULL), vNotifyTM(0), 
	_multPanelBtn(NULL),
	_fsplist(NULL),	fspTag(false),
	cfsp(NULL), fspZone(NULL), search_mdf_wdg(NULL),
	it_cnt(0), it_pre(0), ico_cnt(0), ico_pre(0),
	newMsg(false),	runImg(false),	pIcon(NULL), 
	runVnotify(false), vNotifyTog(false), vNotifyMsg(false),
	notifyTimer(NULL),	tmDoing(false), notifying(false),
	dno_file_lst(AppenAlone)
{
 filesors.append(this);
 homeUnder=_homeUnder;
 homeName=_homeName;
}

FastBlock langlst, stockslst, lifelst;
int langFunc(fsp_dir *pdir, fsp_dir *dir)
{
langlst.add(dir->name);
return 1;
}

int stocksFunc(fsp_dir *pdir, fsp_dir *dir)
{
stockslst.add(dir->name);
return 1;
}

int lifeFunc(fsp_dir *pdir, fsp_dir *dir)
{
lifelst.add(dir->name);
return 1;
}

QToolButton *menuButton(int img, const char *txt, QToolBar *tb, QPopupMenu *menu, int key)
{
QToolButton *btn=new QToolButton(QIconSet(*pixmapLoad(img)), QString::fromUtf8(txt), NULL,NULL,NULL,tb);
btn->setAccel(QKeySequence(key));
btn->setPopup(menu);
btn->setPopupDelay(10);
return btn;
}

void Filesan::modulsInit(bool init)
{
 const char *tmp;
 if(rightFileName(dirNam, init ? &tmp : &Filter)==false){
	char buf[1024];
	sprintf(buf, noneFile, dirNam);
	ManuTxt(-1, buf);
	free(dirNam);
	dirNam=strdup(pcwd);
	}
 int i, L=strlen(dirNam);
 while( ! isDirList(dirNam)){
	char *pt=strrchr(dirNam,'/');
	if(pt)*pt=0;
	else break;
 }
 switch(modul){
 case _OSROOT : 
	setCWD( "/",  INIT_DIRVIEW, NULL);
	treeview->seekDir(dirNam, SHOW_TREE_ORDER);
	break;
 case _FASTTAGS :treeview->createTags();
	break;
 case _PLACE : updateDrivers(); disktime=8;
	break;
 case _FSPLUS : treeview->createFsplus(true);
 }
 for(i=0; i<L; i++)if(dirNam[i]==0)dirNam[i]='/';
}

void  Filesan::exec(char *dnam)
{
 busiedCursor();
 bool wsz;
 int i, t;
 MAU mau;
 freqPix=freqIco;
 _Params=__params;	// in class declare, show_all must lay after _Params
 if(dnam==NULL){
	if(pms_reserveUse && numbRead(fspRoot, reserveId, &mau, 1, false)>-1){
		dirNam=mau.buf;
		goto _skp_;
		}
	else dirNam=(char *)pcwd;
	}
  else dirNam=dnam;
  if(dirNam[0]!='/')dirNam=catstr(pcwd, dirNam, '/');
  else dirNam=strdup(dirNam);

_skp_: p_dtfmt=dtfmtlst.lstIndex(dtfmtCombIdx);
 listview_sort=pms_sort;
 iconview_sort=pms_sort2;
 modul=pms_multPanel;
 sort_ascend=pms_ascend;
 showHide=pms_showHide;
 brwImg=pms_browImage;
 _viewCodec=pms_prgDefaultCodec;
 bakCodec=_viewCodec<0 ? 0 : _viewCodec;
 vStrCodec=_setCodec(_viewCodec);
 strCodec=vStrCodec;
 setCurCodeVal();

 if((wsz=setWdgFrame(this, fspRoot, wdgSizeId))==false)resize(screenWidth*3/4,screenHeight*3/4);
 summaryMenu=new ActMenu(this);
 codecMenu=new QPopupMenu(this);
 confMenu=new ActMenu(this);
 langMenu=new QPopupMenu(this);
 stocksMenu=new ActMenu(this);
 lifeMenu=new ActMenu(this);
 tagMenu=new ActMenu(this);
 operaMenu=new ActMenu(this);
 personMenu=new ActMenu(this);
 newMenu=new ActMenu(this);
 subCode=new QPopupMenu(this);
 ccmprsMenu=new  QPopupMenu(this);
 fspccmprsMenu=new  QPopupMenu(this);

 QFont fnt;
 if( ReadFont(fnt, progFontId) ){
	setFont(fnt);
	setFonts(fnt);
	}
 else getBaseHeight(font());

 const char **_init_=charsFromFSP(6);
 topBar=new QToolBar("Tools", this, Qt::DockTop);
 topBar->setMovingEnabled(false);
 bottomBar=new QToolBar("FBO", this, Qt::DockBottom); // file base opera
 bottomBar->setMovingEnabled(false);
 one=new QSplitter(Horizontal, this);
 setCentralWidget(one);
 mainSplit=new QSplitter(Vertical, one);
 mainBW=new BaseWidget(mainSplit, this);
 mbwId=mainBW->winId();
 QScrollView *vw=pms_listView ? (_filelist=(ListContent *)creatFileList(mainBW, (void *)FileListChs, colOptRslt, useCols,0)) : creatIconView(mainBW);

 pathComb=creatCombo(true, mainBW, pathCombChs, p_pathcomb, combdirImg);
 reFreshBtn=creatPB( mainBW, refreshImg, refreshchs, this, SLOT(refresh()), false, false, Key_F5);

 setWdgSize(vw, fspRoot, listSizeId);
 mainSplit->setResizeMode(mainBW, QSplitter::KeepSize);
 creatMultPanel(NULL);
// setRightJustification(true); // 确保拉伸
 backDirAct=creatTA(this, topBar,  backImg, backDirChs, SLOT(Back()), CTRL+Key_B);
 nextDirAct=creatTA(this, topBar,  nextImg, nextDirChs, SLOT(Next()), CTRL+Key_F);
 parentDirAct=creatTA(this, topBar, upBtnImg, parentDirChs,SLOT(parentDir()), CTRL+Key_Up);
 homeAct=creatTA(this, topBar, orgDirImg, homeChs, SLOT(beginDir()), CTRL+Key_H);
 topBar->addSeparator();
 proEditAct=creatTA(this, topBar, proEditImg, proEditChs, slot_proedit, Key_F6);
 simpleImageAct=creatTA(this, topBar, simpleImageImg, grapSimpleEditChs, SLOT(sImage()), CTRL+Key_I);
 topBar->addSeparator();
 (void)creatTA(this, topBar, diskfindImg, smChs, slot_loadSM, Key_F10);
// topBar->addSeparator();
 (void)creatTA(this, topBar, fspZoneImg, "Fsplus zone", SLOT(fspZone()), CTRL+Key_Return);
 (void)creatTA(this, topBar, pluzoneImg, newPluzone, slot_pluzone, CTRL+Key_P);

 // 以上的菜单会被下面的语句判定是否有效，所以必先创
 if(pms_isMax)showMaximized();
 else {
	show();// statPanel->setScaledContents(true);
	if(wsz)move(wx, wy);
	}
 sbar=new StatusPanel(bottomBar, 0);
 bottomBar->setStretchableWidget(sbar);
 topSbar=new StatusPanel(topBar, 0);
 topBar->setStretchableWidget(topSbar);

 statPanel=new QLabel(bottomBar);
 statPanel->setFrameStyle( QFrame::Panel|QFrame::Sunken );
 if(u_id==0)statPanel->setPaletteForegroundColor(0xf00f00);
 selectDoneAct=addTA(this,  bottomBar, selectImg,  fselTip, fselChs, slot_asSrc, CTRL+Key_S, false, false);
 selectAddAct=addTA(this,  bottomBar, selectAddImg,  selAddTip, selAddChs, slot_addSrc, Key_F3, false, false);
 bottomBar->addSeparator();

 copyAct=addTA(this,  bottomBar, copyImg, copyTip, fcopy, SLOT(fcopy()), SHIFT+Key_Insert, false, false);
 fdupAct=addTA(this,  bottomBar, dupImg,dupTip, dupChs, slot_dup,CTRL+Key_D, false, false );
 bottomBar->addSeparator();
 cpLogAct=creatTA(this, bottomBar, cpLogImg, cpLogTip, SLOT(cpLog()), 0);
 cpLogAct->setEnabled(copyInfoList.count());
 bottomBar->addSeparator();
 deleteAct=addTA(this, bottomBar, delImg, deleteTip, delChs,  slot_del, Key_Delete, false,false);

 newMenu->insertMenu(newDirImg, newDirChs, this, slot_newDir, CTRL+ALT+Key_N );
 newMenu->insertMenu(fileImg, newFileChs, this, SLOT(new()), CTRL+Key_N );

 selectDoneAct->addTo(operaMenu);
 selectAddAct->addTo(operaMenu);
 operaMenu->insertSeparator();
 copyAct->addTo(operaMenu);
 fdupAct->addTo(operaMenu);
 moveAct=creatTA(this, NULL, moveImg, fmove, slot_move, CTRL + Key_M);
 moveAct->addTo(operaMenu);

 linkAct=creatTA(this, NULL, linkOpenImg, creatSymChs, slot_creatSym, CTRL+Key_L);
 linkAct->addTo(operaMenu);
 genArchAct=creatTA(this, NULL, archImg, compressChs, SLOT(cmpr()), 0);
 fspArchAct=creatTA(this, NULL, fspArImg, fspArChs, SLOT(fspAr()), 0);
 dirSumAct=creatTA(this, NULL, dirSummImg, dirSumm, slot_dsum, CTRL+Key_D);
 cp2dirAct=creatTA(this, NULL, cp2dirImg,  cp2dirChs, slot_cp2dir, CTRL+Key_G);
 mv2dirAct=creatTA(this, NULL, mv2dirImg, mv2dirChs, slot_mv2dir, CTRL+Key_I);
 ccmpId=operaMenu->insertMenu(archImg, curCmpr, this, SLOT(ccmp()), 0 );
 for(i=0; i<4; i++)ccmprsMenu->insertItem( _engn[i], i );
 connect(ccmprsMenu, sigactIdx, this, SLOT(ccmps(int)) );
 operaMenu->insertItem(QString::fromUtf8(curCmprs), ccmprsMenu);

 fspccmpId=operaMenu->insertMenu(fspArImg, cfspArChs, this, SLOT(fspCAr()), 0 );
 for(i=0; i<3; i++)fspccmprsMenu->insertItem( _engn[i], i );
 connect(fspccmprsMenu, sigactIdx, this, SLOT(fspCAr(int)) );
 operaMenu->insertItem(QString::fromUtf8(fspArsChs), fspccmprsMenu);
 dccmpId=operaMenu->insertMenu(decompressImg, curDeCmp, this, SLOT(dccmp()), 0);
 operaMenu->insertSeparator();
 deleteAct->addTo(operaMenu);
 operaMenu->insertSeparator();

 proEditAct->addTo(operaMenu);
// operaMenu->insertSeparator();

 renId=operaMenu->insertMenu(-1, renChs, this, slot_ren, Key_F2 );
 renCase0Id=operaMenu->insertMenu( -1, renCase0Chs, this, SLOT(renCase0()),0);
 renCase1Id=operaMenu->insertMenu( -1, renCase1Chs, this, SLOT(renCase1()),0);
 operaMenu->insertSeparator();
 operaMenu->insertItem(*pixmapLoad(newImg), QString::fromUtf8(newChs), newMenu);
 propertiesAct=creatTA(this, NULL, attribImg, attribChs, slot_attrib, Key_F4);
 propertiesAct->addTo(operaMenu);
 selAllAct=addTA(this, NULL, -1, selAllChs, selAllChs, slot_selall, CTRL+Key_A, false,false);
 selAllAct->addTo(operaMenu);
 confMenu->setCheckable(true);
 langMenu->setCheckable(true);
 fsp_dir *fspdir1=_diropen(fspRoot, langDir);
 if(fspdir1){
	DirFullBrow(fspdir1, 2, NULL, langFunc);
	pd_close(fspdir1, 2);
	t=langMenu->insertItem(QString::fromUtf8(lang0), 0);
	if(langIdx==0)langMenu->setItemChecked(langId=t, true);
	langMenu->insertSeparator();
	for(i=1; i<=langlst.count(); i++){
 		t=langMenu->insertItem(QString::fromUtf8(langlst.lstIndex(i-1) ), i);
		if(langIdx&&strcmp(langlst.lstIndex(i-1),selfDir->name)==0)langMenu->setItemChecked(langId=t, true);
	}
 }
 confMenu->insertItem(*pixmapLoad(langImg), QString::fromUtf8(langChs), langMenu);
 connect(langMenu, sigactIdx, this, SLOT(lang(int)) );
 confMenu->insertSeparator();

 showHideId=confMenu->insertMenu(showHideImg, showHideChs, this, SLOT(showHide()), CTRL+ALT+Key_H);
 confMenu->setItemChecked(showHideId, showHide);

 confMenu->insertSeparator();
 caseId=confMenu->insertMenu(-1, caseChs, this, SLOT(case()), 0);
 confMenu->setItemChecked(caseId, pms_case);

 confMenu->insertSeparator();
 confMenu->insertMenu( genSetImg, genSetChs, this, SLOT( genSet() ),0);
 if(modul!=NO_MULT_PANEL)setDirNoSort();
 char buf[1024];
 if(init_rt!=ini_first && init_rt!=ini_norm){
	sprintf(buf, pInfo, rtfn);
	free((void *)rtfn);
	fmtinp(buf,NULL, "\n", 32);
	topSbar->showMsg(buf, 0, 2, 0x530606);  // lost rt-lib of libfsp.so
 }
 modulsInit(true/*SHOW_TREE_LIST*/);
 summBtn=menuButton(aboutImg, mSumm, topBar, summaryMenu, ALT+Key_A);
 operaBtn=menuButton(operaImg, mOpera, topBar, operaMenu, ALT+Key_O);
 tagBtn=menuButton(tagImg, mFastTag, topBar, tagMenu, ALT+Key_T);
 settingBtn=menuButton(settingImg, mSetting, topBar, confMenu, ALT+Key_S);
 personBtn=menuButton(personImg, mPerson, topBar, personMenu, ALT+Key_P);
 codecBtn=menuButton(codecImg, mCodec, topBar, codecMenu, ALT+Key_C);

 setIcon(*pixmapLoad(pluzoneImg));
 sprintf(buf, "%s  (%s)", pluzoneName, logorName(u_id, usrIDs, usrList));
 setCaption(QString::fromUtf8(buf));
 static const char slot_about[]=SLOT(about(int));
 summaryMenu->setItemParameter(summaryMenu->insertMenu(htmlImg, aboutChs, this, slot_about, CTRL+Key_V ), 0);
 summaryMenu->setItemParameter(summaryMenu->insertMenu( faqImg, faqChs, this, slot_about, Key_F1), 3);
 summaryMenu->insertSeparator();
 (void)summaryMenu->insertMenu(Qt3Img, "About Qt3", this, SLOT(Qt3()), 0 );
 summaryMenu->insertSeparator();
 (void)summaryMenu->insertMenu( closeImg, quitChs, this, SLOT(close()), ALT+Key_F4 );
 (void)summaryMenu->insertMenu( quitImg, exitPluzone, qApp, slot_quitPrg, CTRL+Key_Q );
 summaryMenu->insertSeparator();
 (void)summaryMenu->insertMenu( -1, restartChs, this, SLOT(restart()), 0 );
 (void)summaryMenu->insertMenu( -1, shutdownChs, this, SLOT(shutdown()), CTRL+ALT+Key_Q );
 currentView()->setFocus();
 connect( pathComb, sigactIdx, this, SLOT( chPathComb() ) );
 connect(tagMenu, ShowSig, this, SLOT(tagList()) );
// connect(codecMenu,ShowSig, this, slot_popCodecMenu); connect(codecMenu,SIGNAL(aboutToHide()), this, SLOT(releaseCM())); // releaseCodeMenu
 defCode=popCodecMenu(this, codecMenu, subCode, pms_prgDefaultCodec, _viewCodec );
 (void)tagMenu->insertMenu( tagAddImg, tagAddChs, this, slot_addtag,CTRL+Key_T );
 (void)personMenu->insertMenu( personLogImg, pLog, this, SLOT(plog()), 0 );

 (void)personMenu->insertItem(*pixmapLoad(stocksMarketImg), QString::fromUtf8(stocksChs), stocksMenu);
 connect(stocksMenu, sigactIdx, this, SLOT(stocks(int)) );
 connect(stocksMenu, ShowSig, this, SLOT(stocksShow()) );

 (void)personMenu->insertItem(*pixmapLoad(gendateImg), QString::fromUtf8(lifeChs), lifeMenu);
 connect(lifeMenu, sigactIdx, this, SLOT(life(int)) );
 connect(lifeMenu, ShowSig, this, SLOT(lifeShow()) );

 proEdit2Act=creatTA(this, NULL, proEdit2Img, proEdit2, SLOT(proEdit2()), ALT+Key_F6);
// clearWState( WState_Polished );
 free((void *)_init_[0]);
 free((void *)_init_);
 if(modul==_FSPLUS)creatFspList();
 setCWD(dirNam, SHOW_LIST , NULL);
 sortAcc(this, colOptCnt+1);
 normalCursor();
}

void Filesan::setDirNoSort()
{
 dirNoSortId=confMenu->insertItem(QString::fromUtf8(dirNoSortChs), treeview, SLOT(dirNoSort()), 0, -1, dirNoSortMenuPos);
 confMenu->setItemChecked(dirNoSortId, pms_treeDescend==0);
}

void Filesan::multPanelResize(BaseWidget *bw)
{
#define  ButtonWH  26
int w=bw->size().width()-28, x, tx;
if(pms_toolPanelLeft){
	tx=28;	x=1;
	}
else {	
	tx=0;	x= w+1;
	}
treeview->setGeometry(tx,0, w, bw->size().height());

multPanelBtn->setGeometry(x, 2, ButtonWH, ButtonWH);
panelRightBtn->setGeometry(x, 2+(ButtonWH+2), ButtonWH, ButtonWH);
toolPanelBtn->setGeometry(x, 2+(ButtonWH+2)*2, ButtonWH, ButtonWH);

lines[0]->setGeometry(x, 2+(ButtonWH+2)*3, ButtonWH, 5);
treeDescendBtn->setGeometry(x, 2+(ButtonWH+2)*3+6, ButtonWH, ButtonWH);

lines[1]->setGeometry(x, 2+(ButtonWH+2)*4+7, ButtonWH, 5);

fastTagsBtn->setGeometry(x, 2+(ButtonWH+2)*4+14, ButtonWH, ButtonWH);
placeBtn->setGeometry(x, 2+(ButtonWH+2)*5+14, ButtonWH, ButtonWH);
fsplusBtn->setGeometry(x, 2+(ButtonWH+2)*6+14, ButtonWH, ButtonWH);

lines[2]->setGeometry(x, 2+(ButtonWH+2)*7+16, ButtonWH, 5);
listBtn->setGeometry(x, 2+(ButtonWH+2)*7+23, ButtonWH, ButtonWH);
browImageBtn->setGeometry(x, 2+(ButtonWH+2)*8+23, ButtonWH, ButtonWH);
onlyFileBtn->setGeometry(x, 2+(ButtonWH+2)*9+23, ButtonWH, ButtonWH);
}

void Filesan::setFonts(const QFont  & fnt)
{
getBaseHeight( fnt );
summaryMenu->setFont(fnt);
operaMenu->setFont(fnt);
confMenu->setFont(fnt);
tagMenu->setFont(fnt);
personMenu->setFont(fnt);
codecMenu->setFont(fnt);

stocksMenu->setFont(fnt);
lifeMenu->setFont(fnt);
langMenu->setFont(fnt);
newMenu->setFont(fnt);
ccmprsMenu->setFont(fnt);
subCode->setFont(fnt);
fspccmprsMenu->setFont(fnt);
}

void Filesan::setObjsStat(int tag, bool isView)
{
bool W, B, wsel, _sel, exe=(isView ? CurDirMode : tag )&mode_x,
	b1=tag&mode_w,
	sel=tag&mode_r,
	b2= b1 && exe;
int i;
if(isView){
	b1=(CurDirMode&mode_w)&&b1;
	b2=(CurDirMode&mode_w)&&b2;
	sel=(CurDirMode&mode_x)&&sel;
	}

operaMenu->setItemEnabled( renId ,
	isView==false && modul==_FASTTAGS && treeview->currentItem()->parent()==treeview->firstChild() ? true : b1  );

B= (tag&mode_dir)==0 || (tag&mode_sub)==0 || (tag&mode_x);
_sel=B&&sel;

selectDoneAct->setEnabled(_sel);
selectAddAct->setEnabled(_sel);
deleteAct->setEnabled( B&&b1 );

propertiesAct->setEnabled( !isView || exe );

newMenu->setEnabled( (W=(CurDirMode&mode_w)&&(CurDirMode&mode_x)) /*: sel&&(tag&mode_w) */);
wsel=_sel&&W;
operaMenu->setItemEnabled(ccmpId, wsel);
ccmprsMenu->setEnabled(wsel);
operaMenu->setItemEnabled(fspccmpId, wsel);
fspccmprsMenu->setEnabled(wsel);

// operaMenu->setItemEnabled(chtimeId, b2/*&&(tag&mode_dir)*/ );
operaMenu->setItemEnabled(renCase0Id, b2/*&&(tag&mode_dir)*/ );
operaMenu->setItemEnabled(renCase1Id, b2/*&&(tag&mode_dir) */);
selAllAct->setEnabled( (vFileCnt+vDirCnt)>0&& (CurDirMode&mode_x) );
for(i=0; i<fsels.count(); i++)if(namefilters(fsels.lstIndex(i), archNam, 1)==0)wsel=false;
operaMenu->setItemEnabled(dccmpId, wsel);

}

int Filesan::operaState(struct stat64 *st)
{
return (isWritable(u_id, g_id, st) ? mode_w : 0) |(isExecable(u_id, g_id, st) ? mode_x : 0) |(isReadable(u_id, g_id, st) ? mode_r : 0);
}

int Filesan::getItemAttrib(bool vw, bool sub)
{
char *pt=vw ? curSelItemPath() : dirNam ;
if(pt){
  struct stat64 st;
  int rt;
  if(stat64(pt,&st))lstat64(pt, &st);
  rt= operaState(&st) | 
	(S_ISDIR(st.st_mode) ? mode_dir | ( (sub ? subDirCount(pt) : 0) ? mode_sub :0) : 0)
	|(is_dev(st.st_mode) ? mode_dev : 0);
  if (vw)free(pt);
  return rt;
}
return 0;
}

void Filesan::objsUpdate()
{
bool m;
int n=getItemAttrib(true, true);
setObjsStat(n, true);
proEditAct->setEnabled( m=((CurDirMode&mode_x) && (n&mode_r) && (n&mode_dir)==0 && (n&mode_dev)==0) );
simpleImageAct->setEnabled( m );
}

void Filesan::treeUpdateObjs(char *pth)
{
int tag;
struct stat64 st;
char *pt=strrchr(pth,'/');
stat64(pth, &st);
tag=operaState(&st);
if(pt!=pth)*pt=0;
stat64(pth, &st);
*pt='/';
setObjsStat( mode_dir | ( subDirCount(pth) ? mode_sub : 0) | (operaState(&st)&tag), false );
}

void loadSearchModify(Filesan *fs)
{
 if(fs->getSMW())showTop(fs->getSMW());
 else {
	SearchModify *sm=new SearchModify(fs);
	fs->setSMW(sm);
	sm->exe();
	}
}

bool Filesan::event( QEvent *e)
{
int n, T=e->type(), j;
switch( T ){
case QEvent::Timer : if(tmDoing==false){
	tmDoing=true;
	if(showTm){
		if(isActiveWindow()){
			showTm=false;
			killTimer(prgTmId);
			prgTmId=startTimer(500);
		}
		else {
			raise();
			setActiveWindow();
		}
		goto _ex_tm_;
	}

	if(itemDel && ++itemDel>2){
		itemDel=0;
		if(it_cnt>1){
			for(j=0; j<it_cnt-1; j++)delete deleteItems[j];
			memcpy(deleteItems,deleteItems+j, sizeof(LVItem *));
			it_cnt=1;
		}
		goto _ex_tm_;
	}

	if(iconDel>0 && ++iconDel>2){
		iconDel=0;
		if(ico_cnt>1){
			for(j=0; j<ico_cnt-1; j++)delete deleteIcons[j];
			memcpy(deleteIcons, deleteIcons+j, sizeof(IVItem *));
			ico_cnt=1;
		}
		goto _ex_tm_;
	}
	CopyThread *cpthr;
	for(j=0; j<copy_thr.count(); j++){
		cpthr=copy_thr.at(j);
		if(cpthr->getTag()<-1){
			copy_thr.remove(j--);
			if(panelStatus==1)cpthr->releaseCell();
			delete cpthr;
		}
	}
	if(cp_tm){
	    if(copyThreadCount<1){
		cp_tm=0;
		if(stopCopyForExit){
			close(); // click close box when copying
			goto _ex_tm_;
		}
	   }
	}
	else if(selAsSrc.count()){
		struct stat64 st;
		n=selAsSrc.count();
		for(j=0; j<selAsSrc.count(); j++)
			if(lstat64(selAsSrc.lstIndex(j), &st))selAsSrc.rem(j--);
		if(n!=j)PreCopyStats(j);
		}

	if(vNotifyTog){
	    if(++vNotifyTM>4){
	       if(vNotifyMsg==false){
		vNotifyTM=-99999;
		disktime=-99;
		QApplication::postEvent( this, new CustEvents(65000));
		goto _ex_tm_;
	       }
	   }
	   if(vNotifyTM<-1)goto _ex_tm_;
	}
	switch(modul){
	case _PLACE : if(disktime++>2){
			appPost(65015, NULL, this );
			goto _ex_tm_;
			}
		break;
	case _FSPLUS : if(fsptm++>2){
			appPost(65016, NULL, this);
			goto _ex_tm_;
			}
		}

	if(pms_baktm){
		ProEdit *edt;
		for(j=0; j<proEditList.count(); j++){
			edt=proEditList.at(j);
			edt->backup(); 
			}
	}
	}
_ex_tm_:tmDoing=false;	break;
case QEvent::ShowMaximized : pms_isMax=1;
	break;
case QEvent::ShowNormal :
	pms_isMax=0;
	killTimer(prgTmId);
	showTm=true;
	prgTmId=startTimer(50);
	break;
case QEvent::KeyPress : 
	int st;
	st=((QKeyEvent *)e)->state();
	n=((QKeyEvent *)e)->key();
	if(st==ControlButton){
	switch(n){
	case Key_U :
		pathComb->setFocus();
		pathComb->setCurrentText(_Spc);
//		break;
//case Key_2 :case Key_3 :case Key_4 :case Key_5 :case Key_6 :case Key_7 :	case Key_8 :sortView(n);
	}
	}
	else switch(n){
		case Key_F12 :
		   if(proEditList.count())showTop( proEditList.at(0) );
			break;
		case Key_F11 :   if(helpList.count())showTop(helpList.at(0));
		}
	break;
// case QEvent::Resize : =isMaximized(); here oDatVal(before), so ignore ...
case QEvent::Close :
	tmDoing=true;
	if(cp_tm){
		if(infoWidget(Copying, NULL, info_Copying, this)==1){
			for(j=0; j<copy_thr.count(); j++)
				if(copy_thr.at(j)->getFilesor()==this)copy_thr.at(j)->setTag(-1);
			stopCopyForExit=true;
		_hide_return_:	hide();
			}
	_canReturn_ : sysCmdId=-1; // orgVal
		tmDoing=false;
		return false;
		}

	if(search_mdf_wdg){
	    if(search_mdf_wdg->getSmThread()>0){
		search_mdf_wdg->setSmThread(-3);
		goto _hide_return_;
	    }
	    delete search_mdf_wdg;
	}

	for(j=0; j<grapList.count(); j++)
		if( grapList.at(j)->parentWidget()==this )
			grapList.at(j--)->close();

	for(j=0; j<stocksList.count(); j++)
		if( stocksList.at(j)->parentWidget()==this )
			if(stocksList.at(j--)->close()==false)goto _canReturn_;

	for(j=0; j<proEditList.count(); j++)
		if( (Filesan *)proEditList.at(j)->parentWidget()==this )
			if(proEditList.at(j--)->close()==false)goto _canReturn_;

	if(notifyFP)fcntl(notifyFP->_fileno, F_NOTIFY, 0);

	for(j=0; j<attWdgs.count(); j++)
		if( ((QWidget *)attWdgs.at(j))->parentWidget()==this ){
			delete	attWdgs.at(j--);
		}
	for(j=0; j<helpList.count(); j++)
		if( (Filesan *)(helpList.at(j)->parentWidget())==this )
			helpList.at(j--)->close();

	if(fspZone&&fspZone!=(FspCon *)this)delete fspZone;

	filesors.remove(this);
	
	if(filesors.count()<1){
	    MAU mau;
	    if(pms_reserveUse){
		mau.buf=Filter ? catstr(dirNam, Filter, '/') : dirNam;
		mau.len=0;	mau.alen=80;
		numbWrite(fspRoot, reserveId, &mau, 1);
	    }
	    if(genSetWdg)delete genSetWdg;
	    if(panelStatus>0)delete cpThrPanel;
	    if(fsplib){
		runStatus();
		if(pms_isMax==0)saveWdgFrame(this, fspRoot, wdgSizeId);
		if(modul!=NO_MULT_PANEL)saveWdgSize(multfunPanel, fspRoot, treeSizeId);
		saveWdgSize(currentView(), fspRoot, listSizeId);
		if(_filelist)saveListColWidth(_filelist, ColumnWidthsId);
	    }
	for(j=LASTSPACE; j>-1; j--)if(workspace[j])fspDestroy(workspace[j], j ? menuPlusDo : NULL);
	mau.buf=colOptRslt;
	mau.len=colOptCnt*2;
	mau.alen=0;
	numbWrite(fspRoot, colOptId, &mau, 1);
	}
	free(dirNam);
	if(Filter)free((void *)Filter);
}
return QMainWindow::event(e);
}

