/*
	Write by xempo 12-2014
	Free under LGPL
*/

#include <qlistbox.h>
#include <qtextbrowser.h>
#include <qaction.h>
#include <qlineedit.h>
#include <qcombobox.h>
#include "infor.h"
#include "shellcom.h"
#include "write.h"
#include "jxswitch.h"
#include "conspace.h"
#include "extfunc.h"
#include "dirloop.h"
#include "dirext.h"
#include "dlist.h"

#include "filesan.h"
#include "fspcon.h"
#include "fspattr.h"
#include "helpwdg.h"
#include "inputdlg.h"
#include "../rtdata/en/target/filesor.h"
#include "../rtdata/en/target/fspcon.h"
#include "fsplus/objcom/comm.h"

#include "combo.cpp"

extern const char slot_find[], slot_find2[]; // searchmodify.h

const char FspCons[]="FspCons",
	slot_help[]=SLOT(help());

FspCon *Fsp_Zone;

FspCon::FspCon(QWidget *par) : QMainWindow(par, NULL, WType_TopLevel|WDestructiveClose),
	filesor((Filesan *)par), treeview(filesor->getTreeView()),
	enter(false), clib(NULL)
{
setFont(par->font());
resize(screenWidth*4/5, screenHeight*4/5);
_fspcon_=charsFromFSP(10);
}

fsp_lib *testFsp(fsp_lib *fsp)
{
if(fsp){
int i;
for(i=0; i<SPACELIMIT; i++)if(workspace[i]==fsp)return fsp;
}
return NULL;
}

fsp_lib *FspCon::getCurLib()
{
if(clib)clib=testFsp(clib);
return clib;
}

inline void Filesan::setLib(fsp_lib *fsp)
{ cfsp=fsp; }

Filesan *actFilesor()
{
  int i;
  for(i=0;i<filesors.count();i++)
	if(filesors.at(i)==qApp->activeWindow() )return filesors.at(i);
  return NULL;
}

void writeCon(fsp_dir *dir, const char *txt)
{
ProEdit *pe=new ProEdit( Fsp_Zone ?  (Filesan *)Fsp_Zone->parentWidget() : actFilesor(), NULL, -1);
pe->setFspDir(dir);
pe->exec(PRO_FSP_WRITE, txt); // -3
}

void FspCon::exe()
{
QToolBar *tbar=new QToolBar("tb", this, Qt::DockTop),
	*bbar=new QToolBar("bb", this, Qt::DockBottom);
bbar->setMovingEnabled(false);
tbar->setMovingEnabled(false);
brow=new QTextBrowser(this);
brow->setWrapPolicy(QTextEdit::AtWordOrDocumentBoundary);
// connect( brow, SIGNAL(linkClicked(const QString & link)), this, SLOT(recClicked()) );
setCentralWidget(brow);
creatTA(this, tbar, fspSpaceImg, fspVer, SLOT(ver()), Key_F2);
creatTA(this, tbar, publicImg, fspPub, SLOT(CopyRight()), Key_F6);
tbar->addSeparator();

infoAct=creatTA(this, tbar, fspInfoImg, infoChs, SLOT(info()), Key_F4);
closeCurAct=creatTA(this, tbar, closeImg, closeCur, SLOT(closeCur()), Key_F5);

sbar=new StatusPanel(tbar, sbar_Fsplus);

creatTA(this, tbar, setPathImg, chPath, SLOT(pwd()), Key_F8);

tbar->setStretchableWidget(sbar);
creatTA(this, bbar, faqImg, helpChs, slot_help, Key_F1);
input=creatCombo(true, bbar, fspInpChs, p_fspInp, -1);
creatTA(this, bbar, searchImg, screenFind, slot_find, CTRL+Key_F);
creatTA(this, bbar, fastFindImg, screenFindNext, slot_find2, Key_F3);
bbar->setStretchableWidget(input);
setCaption("FreeStar plus zone");
setIcon(*pixmapLoad(fspZoneImg));
show();
}

void menuPlusDo(void *lib)
{
menuPlus.add( ((fsp_lib *)lib)->fname );
}

#include "strins.c"
void FspCon::updateZone(fsp_lib *lib)
{
fsp_lib *tmp=getCurLib();
Fsp_Zone=this;
if(lib)clib=lib;
filesor->setFspCons(this);
if(clib){
    if(clib!=tmp||enter==false){
	char  buf[1024];
	fspInfo(clib->CurDir, buf);
	strcat(buf,"<br/>");
	pdInfo(clib->CurDir, buf+strlen(buf));
	strins(buf, "<table width=100%><tr><td bgcolor=#5CABFF>");
	strcat(buf, "</td></tr></table>");tableMsg=true;
	showInfo(buf, NULL);
	if(filesor->getModul()==_FSPLUS){
		treeview->setFsp(clib);
		treeview->setRecent(clib);
		treeview->createFsplus(false);
	}
	}
}
//else showInfo("  .", NULL);
infoAct->setEnabled(clib);
closeCurAct->setEnabled(clib);
}

void FspCon::fspCom()
{
scopy(InpBuf, input->currentText().local8Bit());
if(InpBuf[0]){
	fsp_lib *fsp=getCurLib(), *tmp;
	fsp_dir *dir1=fsp ? fsp->CurDir : NULL;
	int j, L=strlen(InpBuf);
	bool space;
	char *pt, *pth;
#define  fspInpList			_List[20]
	if(fspInpList.add(InpBuf)>-1)
		input->load(p_fspInp, -1);
	OverWrite=0;
	bakdscpt=0x7fff;
	showdata=showdata+(tableMsg ? "<font color=#005400><b>" : "<br /><font color=#105010><b>") + InpBuf+ "</b></font>";
	tmp=comRun(fsp, InpBuf, 0, NULL);
	switch(lock){
	case 1 :	lock=0;
	default :	showInfo(NULL,NULL);
//		break;
//	case 2 : break;
	}
	if( (space=(tmp!=fsp)) )
		updateZone(tmp);
	if(tableMsg)tableMsg=false;
	if(filesor->getModul()==_FSPLUS&&bakdscpt>0x7ffd)
	  switch(CommNumb){
	  case FSP_cd : if(/*clib&&*/dir1!=clib->CurDir){
			treeview->setFspDir(clib->CurDir);
			treeview->deelFspDir(clib->CurDir, FSP_cd);
			}
			break;
	  case FSP_rescudir : /*if( isCurOpera )*/{
				treeview->selFspDir((LVItem *)treeview->currentItem(), treeview->getFspDir(), 2/*|128*/);
				goto _info_;
			}
		//	break;
	  case FSP_chmode : {
			LVItem *it=treeview->seekFspDir(clib, fspdirnam, FSP_chmode);
			free(fspdirnam);
			dir1=treeview->itemFspDir(it);
			treeview->freshItem(it, dir1, loopMsg&LoopDirSub);
			pd_close(dir1, 2);
			}
			break;
	  case FSP_creat :
	  case FSP_newspace :
	  case FSP_workspace :
	  case FSP_open : if(space)filesor->setFsptm(6);
			break;
	  case FSP_rescue :
	  case FSP_rescues :
	  case FSP_arfile :
	  case FSP_write : 
	  case FSP_insert : 
	  case FSP_append :
	  case FSP_add :	BrowNumbs(treeview->getFspDir(), _selFspNum);
			goto _info_;
	  case FSP_erase :
	  case FSP_rm :
	  case FSP_ren :
	  case FSP_del :
	  case FSP_rmdir :
	  case FSP_mkdir :	pt=InpBuf+strlen(InpBuf)+1;
			if(isNumb(pt)){//  sure vlist-showing ...
				LVItem *it1=filesor->getItem(pt);
				if(CommNumb!=FSP_ren)delete it1;
				else {
					j=strlen(pt);
					pt[j]=32;	pt[j]=0;
					it1->_setName(pt);
				}
			}
			else {
				j=strlen(pt);
				if(pt+j<InpBuf+L)pt[j]='/';
				if(*pt!='/'){
					pth=pdPathNam(clib->CurDir,NULL,0);
					pt=catstr(pth, pt, strlen(pth)>1 ?  '/' : 0);
					free(pth);
					}
				treeview->seekFspDir(clib, pt, CommNumb);
			}
			_info_: filesor->showFspInfo(clib->CurDir);
	}
	switch(CommNumb){
	case FSP_exit :
	case FSP_quit : 
		for(j=LASTSPACE; j>0; j--)if(workspace[j])fspDestroy(workspace[j], menuPlusDo);
		close();
		return;
	}
}
input->lineEdit()->selectAll();
}

bool FspCon::event( QEvent *e )
{
int k, m;
switch(e->type()){
case QEvent::KeyPress :
	k=((QKeyEvent *)e)->key();
	m=((QKeyEvent *)e)->state();
	switch(k){
	case Key_Q :
		if(m==ControlButton)QApplication::postEvent( qApp, new QCloseEvent );
		return true;
	}
	break;
case QEvent::WindowActivate :
	Fsp_Zone=this;	fspX=this;
	break;
case QEvent::Close :
	filesor->setLib(getCurLib());
	filesor->setFspCons(NULL);
//	input->comboTo(p_fspInp);
	Fsp_Zone=NULL;
	free((void *)_fspcon_[0]);
	free(_fspcon_);
//	break;	
}
return QMainWindow::event(e);
}

void getMess(const char *buf)
{
if(Fsp_Zone&&(Fsp_Zone==qApp->activeWindow()||lock==-1)){
  if(buf==NULL)Fsp_Zone->getBrowser()->clear();
  else if(buf[0]==0)Fsp_Zone->getInput()->listBox()->clear();
     else Fsp_Zone->showInfo(buf, NULL);
}
else {
  Filesan *pfs=actFilesor();
  if(pfs){
	pfs->stBar()->showMsg(buf, 99, 1, bakdscpt>0x7ffd ? 0x000099 : 0x600604);
	bakdscpt=0x7fff;
	return;
	}
  ManuTxt(-1, buf);
  }
}

int showMess(const char *txt)
{
if(txt==NULL){
  Filesan *pfs=actFilesor();
  if(pfs){
	char *pt=getInfor(idxdscpt, 1);
	pfs->stBar()->showMsg(pt, 99, 1, 0x600604);
	free(pt);
	}
}
else if(Fsp_Zone&&(Fsp_Zone==qApp->activeWindow()||lock==-1))Fsp_Zone->showInfo(txt, NULL);
     else getMess(txt);
return 0;
}

void outText(int x, int attrib, const char *buf)
{
#define  colorCnt   7
static const char fmt[]="<font color=#%06x>%s</font>";
static int color[colorCnt]={ 31, 32, 3, 7,14, 34, 33};
static int cvc[colorCnt]={0xa01212, 0x189020, 0xba7035, 0x008989, 0x307060, 0x284eff, 0xab9020};
int i;
char *txt=(char *)malloc(x+strlen(buf)+32);
for(i=0; i<colorCnt; i++)if(color[i]==attrib){
	attrib=cvc[i];
	break;
	}
for(i=0;i<x;i++)txt[i]=32;
sprintf(txt+i, fmt, attrib, buf);
if(Fsp_Zone&&Fsp_Zone==qApp->activeWindow()){
	getMess(txt);
	Fsp_Zone->setEnter(false);
}
// else ManuTxt(-1, buf);
free(txt);
}

void FspCon::addInfo(const char *txt)
{
if(txt){
	static const char enterChs[]="\n";
	int i, len, T=0;
	for(i=0; txt[i]==32 || txt[i]==9 || txt[i]=='\n'; i++ );
	if(txt[i]!='<' && strstr(txt, "<font")==NULL && strstr(txt, "<table")==NULL ){
		char *dat;
		for(i=0; txt[i]; i++)if(txt[i]=='<')T++;
		if(T){
		  dat=(char *)malloc(i+T*3+2);
		  for(i=0, T=0; txt[i]; i++){
			if(txt[i]=='<'){
				dat[T++]='&';
				dat[T++]='l';
				dat[T++]='t';
				dat[T++]=';';
			}
			else dat[T++]=txt[i];
		  }
		  dat[T]=0;
		  txt=dat;
		}
	}
#define  SizLmt  6000
	len=showdata.length();
	if(len>SizLmt){
		i=showdata.find(enterChs, len-SizLmt);
		if(i<0)i=showdata.find("<br/>", len-SizLmt);
		showdata=showdata.right( len- i );
	}
	if(enter&&showdata.isEmpty()==false)showdata=showdata +  enterChs  + txt;
	else showdata+=txt;
	if(T)free((void *)txt);
	showdata.replace("\n\n", enterChs);
	showdata.replace("\n<table", "<br/><table"); // init-widget,  "<table ..." has some wrong
	showdata.replace("</table>\n", "</table>");
}
}

void FspCon::showInfo(const char *txt, const char *cap)
{
addInfo(cap);
addInfo(txt);
if(lock<1){
	if(Fsp_Zone!=qApp->activeWindow()){
		raise();
		setActiveWindow();
		}
	setUpdatesEnabled(false);
	brow->setText(QString::fromUtf8(QString("<html><pre>") + showdata + "</pre></html>"));
	brow->moveCursor(QTextEdit::MoveEnd, false);
	setUpdatesEnabled(true);
}
enter=true;
}

QMetaObject *FspCon::metaObj = 0;
static QMetaObjectCleanUp cleanUp_FspCon( FspCons, &FspCon::staticMetaObject );
QMetaObject *FspCon::staticMetaObject()
{
if( ! metaObj ){
 static const QMetaData btn_tbl[]={
	{ "help()" , &slot_0_0, QMetaData::Private },
	{ "ver()" , &slot_0_0, QMetaData::Private },
	{ "CopyRight()" , &slot_0_0, QMetaData::Private },
	{ "info()" , &slot_0_0, QMetaData::Private },
	{ "closeCur()" , &slot_0_0, QMetaData::Private },
	{ "closeAll()", &slot_0_0,  QMetaData::Private },
	{ "pwd()" , &slot_0_0, QMetaData::Private },
	{ "lnkopen()" ,&slot_0_0, QMetaData::Private }, // 7
	{"selAs()", &slot_0_0, QMetaData::Private },
	{ "quitPrg()",&slot_0_0, QMetaData::Private },
	{ "popAct(int)", &slot_int,  QMetaData::Private },
	{"find()", &slot_0_0, QMetaData::Private },
	{"find2()", &slot_0_0, QMetaData::Private }, // dlg_findnext
	{"popPluzone()" ,&slot_0_0, QMetaData::Private }
	
	};
 metaObj= QMetaObject::new_metaobject(FspCons, QMainWindow::staticMetaObject(), btn_tbl, 14,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
cleanUp_FspCon.setMetaObject(metaObj);
}
return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool FspCon::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

QString fspfnd;
bool FspCon::qt_invoke(int _id, QUObject *_o)
{
int  sw=_id-staticMetaObject()->slotOffset();
static const char *coms[7]={"help", "ver", "copyright", "info", "close", "closeall", "pwd"};
switch(sw){
case 6 : if( chdir(filesor->getDirNam()) )break;
case 5 :
case 4 :	// for(j=LASTSPACE; j>0; j--)if(workspace[j])fspDestroy(workspace[j], menuPlusDo);	break;
case 3 : // fspDestroy(clib, menuPlusDo);	break;
case 2 :
case 1 :
case 0 : {
	fsp_lib *fsp;
	scopy(InpBuf, coms[sw]);
	Fsp_Zone=this;
//	if((sw==3 ||sw==4) && clib)showInfo(NULL, " .");
	fsp=getCurLib();
//	if(fsp)pdTest(fsp, fsp->CurDir);
	clib=comRun(fsp, InpBuf, 0, NULL);
	if(fsp!=clib)updateZone(clib);
	}
	break;
case 7 : //	{ "lnkopen()" ,&slot_0_0, QMetaData::Private } ......
	filesor->doProEdit( __from_unicode(brow->selectedText()), false);
	break;
case 8 : // 	{"selAs()", &slot_0_0, QMetaData::Private } ......
	selAsSrc.resetMem(strdup(brow->selectedText()), ";\n");
	filesor->setCopyStats(selAsSrc.bufferString('\n') );
	break;
case 9 : //	{ "closeAll()", &slot_0_0,  QMetaData::Private }
	QApplication::postEvent( qApp, new QCloseEvent );
	break;
case 10 : updateZone(workspace[_o[1].payload.i]);
	filesor->setFsptm(6);
	break;
case 11 :
case 12 :
	if( sw==11 || fspfnd.length()<1 ){
	InputDlg fndwdg(this, 1, pms_fspConChks, searchImg);
	Msg=fndwdg.exe(fspfnd, brow->selectedText(), p_fspfnd, NULL, NULL);
	if((Msg&7)!=0/* btn-index */)return false;
	pms_fspConChks=Msg;
	}
	if(brow->find( fspfnd, Msg&chkCase, Msg&chkWord, (Msg&chkBackward)==0)==false )
		infoWidget( fspfnd, NULL, infoNoFound, this );
	break;
case 13 : showTop(filesor);
	break;
default : return QMainWindow::qt_invoke(_id, _o);
}
return true;
}
