/*
	Write by LinJiangHua(xempo) 01-2015
	Free under LGPL
*/
#include <qtoolbutton.h>
#include "filesan.h"
#include "treeview.h"
#include "fspcon.h"
#include "xfunc.h"
#include "conspace.h"
#include "dirloop.h"
#include "dirext.h"
#include "fsplus/objcom/comm.h"
#include "../rtdata/en/target/filesor.h"

extern fsp_lib *testFsp(fsp_lib *fsp); // fspcon.cpp

const QPixmap *_OEMdir;

#define  OldTag  1

void removeLeft(LVItem *it)
{
LVItem *sit;
while(it){
	sit=(LVItem *)it->nextSibling();
	delete it;
	it=sit;
}
}

fsp_lib *TreeView::itemFspRoot(LVItem *it)
{
while(it->parent()!=NULL)
	it=(LVItem *)it->parent();
return workspace[it->getTypeOr()];
}

fsp_dir *TreeView::itemFspDir(LVItem *it)
{
QCString s;
while(it->parent()!=NULL){
	s=QCString("/")+it->text(0).local8Bit()+s;
	it=(LVItem *)it->parent();
	}
return pd_open((fsp_dir *)workspace[it->getTypeOr()], s, DIR_READ);
}

static BOOL pdTest(fsp_lib *fsp, fsp_dir *dir)
{
if(fsp){
  int i;
  for(i=0; i<fsp->cnt_usedir; i++)
      if(fsp->usedirs[i]==dir)return True;
/*  if(dir==fsp->CurDir)fsp->CurDir=(fsp_dir *)fsp;*/
}
return False;
}

fsp_dir *TreeView::testFspDir(LVItem * it)
{
fspLib=itemFspRoot(it);
if((fsp_dir *)fspLib==fspDir)return fspDir;
if(pdTest(fspLib, fspDir)){
	fspLib->CurDir=fspDir;
	return fspDir;
}
treeLostDel( it );
return NULL;
}

void TreeView::chFspDir(LVItem *it)
{
fsp_lib *lib;
lib=itemFspRoot(it);
filesor->cfsp=lib;
if(fspDir && pdTest(lib, fspDir) )pd_close(fspDir, 2);
fspDir=selFspDir(it, NULL, 1|2|64);
lib->CurDir=fspDir;
if(filesor->fspZone)filesor->fspZone->setCurLib(lib);
}

LVItem *TreeView::deelFspDir(fsp_dir *dir, int msg)
{
char *pth=pdPathNam(dir, NULL,0);
LVItem *it=seekFspDir(dir->lib, pth, msg);
free(pth);
return it;
}

void TreeView::freshItem(LVItem *it, fsp_dir *dir, bool sub)
{
	bool B;
	if(sub){
		dir->lib->x_msg|=1;
		selFspDir(it, dir, (it==selectedItem() ? 1|2|64 : 2)|128);
		dir->lib->x_msg&=~1;
	}
	B=(dir->mode&FSP_MW);
	it->setPixmap(0, *freqIco[B ? ICO_NORM+DIR_OFF : ICO_NOWRITE]);
	it->setRenameEnabled(0, B );
	it->setRenameEnabled(3, B );
}

LVItem *TreeView::seekFspDir(fsp_lib *fsp, const char *path, int msg)
{
int i;
char *dnam, *pt, *pCreat, tmp[strlen(path)+2];
LVItem *it;
for(i=0; i<SPACELIMIT&&workspace[i]!=fsp; i++);
it=(LVItem *)firstChild();
while(it && it->getTypeOr()!=i)it=(LVItem *)it->nextSibling();
// org=it;
scopy(tmp, path);
pt=tmp;
switch(msg){
case FSP_mkdir : pCreat=strrchr(tmp, '/')+1;
	if(pCreat==tmp+1)goto _jmp_; // like :  /input
	break;
}
_start_ : dnam=pt+1;
while(*dnam=='/')dnam++;
if( pt=strchr(dnam, '/') )*pt=0;
if(*dnam==0) goto _jmp_;
for(it=(LVItem *)it->firstChild(); it; it=(LVItem *)it->nextSibling() ){
    if(strcmp(dnam, it->fnam)==0){
   _jmp_: switch(msg){
	case FSP_chmode :
	case FSP_cd :
		if(pt){
			selFspDir(it, NULL, 2|128);
			it->setOpen(true);
			goto _start_;
		}
		else {
			if(msg==FSP_cd){
			   if(it!=(LVItem *)currentItem()){
				skpslot=true;
				setSelected(it,true);
				}
		_vis_:	    ensureItemVisible(it);
			}
			else if(it==selectedItem())goto _vis_;
			}
		goto _end_;
	case FSP_del :
	case FSP_rmdir : if(pt)goto _start_;
		treeDel(it);
		goto _end_;
	case FSP_mkdir : if(pt){
			if(pCreat==pt+1){
			_jmp1_:	LVItem *itm=(LVItem *)it->firstChild();
				while(itm && itm->nextSibling())itm=(LVItem *)itm->nextSibling();
				itm=new LVItem(it, itm, pCreat);
				itm->setPixmap(0, *freqIco[ICO_NORM+DIR_OFF]);
				goto _end_;
			}
			goto _start_;
			}
	}
	}
}

/*---------- no seeked item :
switch(msg){
case FSP_del :
case FSP_rmdir : qWarning("rmdir fail");
	break;
case FSP_cd : qWarning("cd fail");
		break;
case FSP_mkdir : qWarning("no expand yet");
	break;
}
//---------- no seeked item ----------------
*/
_end_: return it;
}

void TreeView::createFsplus(bool init)
{
int i;
fsp_lib *fsp;
const char *pt, *tmp;
LVItem *it, *after, *sit, *sel=(LVItem *)selectedItem();
filesor->fsptm=0;
if(init){
	filesor->modul=_FSPLUS;
	fspDir=NULL;
	clear();
	setRootIsDecorated(true);
}
fspSel=NULL;
it=(LVItem *)firstChild();
after=it;
if(_OEMdir==NULL)_OEMdir=new QPixmap(*pixmapLoad(OEMdirImg));
i=0;
recentFsp=testFsp(recentFsp);
while( i<SPACELIMIT ){
	if(workspace[i]){
		fsp=workspace[i];
		tmp=fsp->fname;
		if(access(tmp, F_OK)){ // be delete ...
			fclose(fsp->fpt);
			free(fsp);
			workspace[i]=NULL;
			goto _skp_;
			}
		while(it){
			if(strcmp(it->fnam, tmp)==0){
				after=it;
				if(fsp==recentFsp)fspSel=it;
				it=(LVItem *)it->nextSibling();
				goto _skp_;
				}
			sit=(LVItem *)it->nextSibling();
			delete it;
			it=sit;
		}
		pt=strrchr(tmp, '/');
		it=new LVItem(this, after, pt ? pt+1 : tmp);
		if(fsp==recentFsp)fspSel=it;
		it->_setName(tmp);
		it->setPixmap(0,*pixmapLoad(fsp->openMode&OpenAlway? fspRTLImg : fspSpaceImg));
		it->setTypeOr(i);
		selFspDir(it, (fsp_dir *)fsp, 2|128);
		sit=(LVItem *)it->nextSibling();
		after=sit ? sit : it;
		it=sit;
		}
	_skp_:	i++;
	}
removeLeft(after ? (LVItem *)after->nextSibling() : NULL);
if(init)filesor->treeDescendBtn->setOn(pms_treeDescend<0);
else {
    if(fspSel){
	recentFsp=NULL;
	while(sel){
		if(sel==fspSel)return;
		sel=(LVItem *)sel->parent();
		}
	setSelected(fspSel, true);
	return;
    }
    if(selectedItem()==NULL)setSelected(currentItem(), true);
}
}

void TreeView::sortSub()
{
int t;
LVItem *it, *sit;
char *chs;
filesor->fsptm=0;
it=(LVItem *)firstChild();
disconnect(this, sig_expand, this, slot_expand );
while(it){
	chs=strdup(it->fnam);
	t=it->getType();
	it=sortItem(it, -pms_treeDescend, strrchr(chs,'/')+1);
	free(it->fnam);
	it->fnam=chs;
	it->setType(t);
	it=(LVItem *)it->nextSibling();
}
connect(this, sig_expand, this, slot_expand );
}

int _selFspNum(fsp_dir *pdir, BYTE *unit)
{
int i, cnt=pdir->Num_FCUs_Block, unitlen=pdir->Num_FCU_Len;
Filesan *fs=(Filesan *)pdir->lib->xParent;
for(i=0; i<cnt; i++, unit+=unitlen)fs->addNumb(pdir, unit, false /* wait ...*/);
return 1;
}

int digei;
int _selFspDir(fsp_dir *pdir, fsp_dir *dir)
{
const QPixmap *pix;
LVItem  *sub, *sorg, *nx, *it=(LVItem *)pdir->pX;
sorg=(LVItem *)it->firstChild();
nx=sorg;
while(nx){
	if(strcmp(dir->name, nx->fnam/*text(0).local8Bit()*/)==0){
		sub=nx;	sub->setTypeOr(0);
		if(pdir->lib->x_msg&1)goto _skp1_;
		else goto _skp2_;
		}
	nx=(LVItem *)nx->nextSibling();
}

nx=NULL;
while(sorg){
	if((namcmp(sorg->fnam, dir->name, __params[30])>0)==(__params[2]>0) )break;
	nx=sorg;
	sorg=(LVItem *)sorg->nextSibling();
	}
sub=new LVItem(it, nx, dir->name);
_skp1_: if(dir->mode&FSP_OEM)pix=_OEMdir;
else if((dir->mode&FSP_MW)==0)pix=freqIco[ICO_NOWRITE];
     else {
	pix=freqIco[ICO_NORM+DIR_OFF];
	sub->setRenameEnabled(0, true);
	}
sub->setPixmap(0, *pix);
_skp2_: dir->pX=sub;
if(++digei<2)
	DirFullBrow(dir, 2, NULL, _selFspDir);
digei--;
return 1;
}

fsp_dir *TreeView::selFspDir(LVItem *it, fsp_dir *pdir, int msg)
{
if(pdir==NULL)pdir=itemFspDir(it);
if(pdir){
	if(msg&64)filesor->showFspInfo(pdir);
	if(msg&1)filesor->_fsplist->clear();
	pdir->lib->xParent=filesor;
	pdir->pX=it;
	digei=0;
	DirFullBrow(pdir, msg, _selFspNum, _selFspDir);
	LVItem *sit=(LVItem *)it->firstChild(), *tmp;
	while(sit){
		tmp=(LVItem *)sit->nextSibling();
		if(sit->getTypeOr()==OldTag)delete sit;
		else sit->setTypeOr(OldTag);
		sit=tmp;
	}
	if(msg&128)pd_close(pdir, 2);
//	removeLeft(lvit ? (LVItem *)lvit->nextSibling() : NULL);
	return pdir;
}
statusBarMsg(filesor->sbar, noneFile, it->fnam, 0x802020, 1|4);
treeLostDel(it);
return NULL;
}
