/*
  Free under LGPL
  write by xempo 11-2013
*/

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qcursor.h>
#include "inputdlg.h"
#include "combo.h"
#include "xfunc.h"
#include "copy.h"
#include "libnorm.h"
#include "../rtdata/en/target/filesor.h"
#include "infowidget.cpp"

QString replchs;

int buttonMsg, iniSwitch;

static const char InputDialog[]="InputDlg",
	separs[]="\\";

extern const char clickSig[];

InputDlg::InputDlg(QWidget *par, int id, int m, int img) : QDialog(par),
	Id(id), modes(m)
{
  if(img>-1)setIcon(*pixmapLoad(img));
  setFont(par->font());
}

InputDlg::~InputDlg()
{
free(combo);
if(chkcnt>0)free(chk);
}

int InputDlg::exe(QString &retS, const QString &pre, FastBlock *combo1lst, const QString &pre2, FastBlock *combo2lst)
{
  int i, t, y1, len, CRC, wd,
  fntSz=baseHeight, labscnt;
  QLabel *lab1;
  MAU mau[4];
  fsp_dir *fspInput=_diropen(selfDir, "input");
  if(numbRead(fspInput, Id, mau, 4, true)==-1)return -1;
  pd_close(fspInput, 2);
  FastBlock btns(mau[3].buf, separs), chks(mau[2].buf, separs), labs(mau[1].buf, separs);
  setCaption(QString::fromUtf8(mau->buf));
  free(mau->buf);
  chkcnt=chks.count();
  labscnt=labs.count();
  QPushButton *Btn[btns.count()];
  wd=400*fntSz/_baseH_;
  y1 = labscnt + (chkcnt ? 2 : 0 );
  setFixedSize(wd, (118 + y1*24  )*fntSz/_baseH_); // 24 ought to chnage to fontSize...
  combo=(Combo **)malloc(sizeof(Combo *)*labscnt);
  if(chkcnt>0)chk=(QCheckBox **)malloc(sizeof(QCheckBox *)*chkcnt);
  int x, w, h;
  x=scalefloat(88);	w=scalefloat(286);
  h=inputH;
  for(i=0; i<labscnt; i++){
	lab1 = new QLabel(Id==6/*stocks*/&&i>0 ? retS : QString::fromUtf8(labs.lstIndex(i)), this);
	t=scalefloat(24);	
	lab1->setGeometry(t, scalefloat(24+i*46), Id==6&&i>0 ? wd-t-t : scalefloat(54), scalefloat(fntSz+2));
	lab1->setAlignment(Qt::AlignCenter);
	if(Id!=6||i<1){
		combo[i]=creatCombo(Id!=5, this, i<2 ? comboChs[i] : NULL,
			i<2 ? (i ? combo2lst : combo1lst) : NULL, -1 );
		combo[i]->setCurrentText( i>0||Id==6 ? (pre2.isEmpty()? combo[i]->currentText() : pre2) : 
			(pre.isEmpty()? (retS.isEmpty() ? combo[i]->currentText(): retS) : pre) );
		if(i==0 && Id!=5)combo[i]->lineEdit()->selectAll();
		combo[i]->setGeometry(x, scalefloat(24+i*46-comD/2), w, h);
	}
	}
  CRC=5*fntSz;
  if(chkcnt){
    QFontMetrics fmtcs(font());
    static const int swi[5]={ chkCase, chkWord, chkBackward,0,0 };
    len=btnsLen(chkcnt, (const char **)chks.plist(), font(), NULL, false)+(chkcnt-1)*(fntSz*2);
    i=(wd-len)/2;  // begin pos
    for(t=0; t<chkcnt; t++){
	chk[t] = new QCheckBox(QString::fromUtf8(chks.lstIndex(t)), this);
	len=fmtcs.size(Qt::SingleLine, QString::fromUtf8(chks.lstIndex(t))).width()+fntSz*2;
	if(len<CRC)len=CRC;
	chk[t]->setGeometry(i, scalefloat(24+labscnt*46)-comD, len, fntSz*2);
	chk[t]->setChecked(modes&swi[t]);
	i+=len+scalefloat(4) +2*fntSz;
	}
  }
 if(Id==5){ // all Id in rls/runtime.rls, dir = "input" 
	combo[1]->setEnabled(modes&64);
	connect(chk[0], clickSig, this, SLOT(chk()) );
	}

  createBtns(this, Btn, (const char **)btns.plist(), btns.count(), wd, (64 +y1*24) *fntSz/_baseH_, slot_btn, NULL);
  Btn[0]->setDefault(true);
  buttonMsg=NO_BTN_ID;
  exec();

  if(buttonMsg==NO_BTN_ID||combo[0]->currentText().isEmpty())return -1;
  retS=combo[0]->currentText();
  if(combo1lst)combo1lst->add(retS.utf8());
  if(labscnt>1&&Id!=6/*stocks*/){
	replchs=combo[1]->currentText();
	if(combo2lst&&replchs.isEmpty()==false)combo2lst->add(replchs.utf8()); // finddlg
	}

  for(i=0;i<chkcnt;i++)buttonMsg|=chk[i]->isChecked() ? 64<<i : 0;
  return buttonMsg;
}

QMetaObject *InputDlg::metaObj = 0;
static QMetaObjectCleanUp cleanUp_InputDlg( InputDialog, &InputDlg::staticMetaObject );
QMetaObject* InputDlg::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{"btn1()", &slot_0_0,  QMetaData::Private },
	{"btn2()", &slot_0_0,  QMetaData::Private },
	{"btn3()", &slot_0_0,  QMetaData::Private },
	{"btn4()", &slot_0_0,  QMetaData::Private },
	{"chk()", &slot_0_0, QMetaData::Private }
    };
    metaObj = QMetaObject::new_metaobject(InputDialog, QDialog::staticMetaObject(), slot_tbl, 5,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    cleanUp_InputDlg.setMetaObject( metaObj );
    }
  return metaObj;
}

#ifndef QT_NO_PROPERTIES
bool InputDlg::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES

bool InputDlg::qt_invoke( int _id, QUObject* _o )
{
int  sw=_id - staticMetaObject()->slotOffset();
switch(sw){
case 4 : combo[1]->setEnabled(chk[0]->isChecked()); // simpleImage
	break;
case 2 : 
case 3 : 
case 0 :  
case 1 :	buttonMsg=sw;		close();
	break;
default : return QDialog::qt_invoke(_id, _o);
}
return true;
}
