/*
    LinJiangHua(xempo) write in 2011
    Copyright LinJiangHua 2011
*/

#include <qapplication.h>
#include <qcursor.h>
#include "filesan.h"
#include "xfunc.h"
#include "infowidget.h"
#include "treeview.h"
#include "searchmodify.h"
#include "../rtdata/en/target/filesor.h"

const char showY[]="Yes", showN[]="No";

#define  RootColor  0xf00f00

QPixmap *drgpix;

LVItem::LVItem(LVItem *p, LVItem *after, const char *txt, QTextCodec *codec) : 
	QListViewItem(p, after, tranText(codec,txt)), fnam(strdup(txt))
{
type = (((ListContent *)listView())->getId()==T_TreeView && uId==0) ? RootColor<<8 : 0;
}

LVItem::LVItem(LVItem *p, const QString txt) : QListViewItem(p, txt),
	fnam(strdup(strCodec->fromUnicode(txt)))
{
type = (((ListContent *)listView())->getId()==T_TreeView && uId==0) ? RootColor<<8 : 0;
}

LVItem::LVItem(QListView *v, LVItem *after, const char *txt, QTextCodec *codec, bool isdir) :
	QListViewItem(v, after, tranText(codec,txt)),
	fnam(strdup(txt)), _dir(isdir)
{
type= (((ListContent *)v)->getId()==T_TreeView && uId==0) ? RootColor<<8 : 0;
}

LVItem::LVItem(QListView *view, const QString txt) :
	QListViewItem(view, txt), fnam(strdup(strCodec->fromUnicode(txt)))
{
type = (((ListContent *)view)->getId()==T_TreeView && uId==0) ? RootColor<<8 : 0;
}

// above would be dir

LVItem::LVItem(QListView *view, LVItem *after, int T) : QListViewItem(view, after),
	type(T), fnam(NULL)
{
}

LVItem::LVItem(LVItem *p, LVItem *after) : type(0),
	QListViewItem(p, after), fnam(NULL)
{
}

void LVItem::paintCell( QPainter *p, const QColorGroup &cg,
				 int column, int width, int alignment )
{
    if ( type>0xff ){ // 24bit + 8bit(0xff)
	QColorGroup _cg( cg );
	_cg.setColor( QColorGroup::Text, type>>8 );
	QListViewItem::paintCell( p, _cg , column, width, alignment );
	}
    else QListViewItem::paintCell( p, cg , column, width, alignment );
}

LVItem::~LVItem()
{
if(fnam)free(fnam);
}

void LVItem::_setName(const char *nam)
{
if(fnam)free(fnam);
fnam=strdup(nam);
}

#define  ListViewCount  7

const char treeViewChs[]="treeView", FileListChs[]="FileLst", OptListChs[]="OptLst", LnkTogListChs[]="LnkTogLst",
	personListChs[]="personLst", fspListChs[]="fspLst", FindListChs[]="FindLst", 
	*listName[ListViewCount]={ treeViewChs, FileListChs, OptListChs, LnkTogListChs, fspListChs, FindListChs, personListChs };

char *treeFullPath(LVItem *it, bool renMsg)
{
char *pth=strdup(renMsg ? __from_unicode(it->text(0)) : it->fnam),
	*tmp=pth;
while((it=(LVItem *)it->parent())){
	pth=catstr(it->fnam, pth, '/');
	free(tmp);
	tmp=pth;
	}
 return pth;
}

ListContent::ListContent(QWidget *wdg, const char *name, int id, Filesan *fs) : QListView(wdg, name),
	filesor(fs), pressMouse(false), Id(id), itemCanDrop(true),
	tms(0), dropTim(0), lostId(0),
	diskItem(NULL), dropMeet(NULL)
// stayItem(NULL), oldItem(NULL)   in  MoveEvent(...)
{
viewport()->setAcceptDrops(true);
// setResizeMode(QListView::NoColumn);
}

LVItem *ListContent::Index(int idx)
{
int i;
LVItem *item=(LVItem *)firstChild();
for(i=0; i<idx; i++)item=(LVItem *)item->nextSibling();
return item;
}

inline bool TreeView::testLost(/*LVItem *it*/)
{ 
bool rt= lostTag;
lostTag=false;
return rt;
}

inline void TreeView::treeRemove(LVItem *it)
{
treeDel(it ? it : lostItem);
lostTag=false;
setSelected(currentItem(), true);
}

void ListContent::contentsMousePressEvent( QMouseEvent* e )
{
 msgboxSignal=-1;
 QListView::contentsMousePressEvent(e);
// 此时会发生中断信号selectionChanged
 if(msgboxSignal==-1){
	int M=filesor->getModul();
	presspos = e->pos();
	QPoint point=contentsToViewport(presspos);
	LVItem *it = (LVItem *)itemAt( point ); 
	switch(Id){
	case T_SearchList : 
		if( e->button()==Qt::RightButton){
			((SearchModify *)topLevelWidget())->popRightMenu(it);
			break; // return;
			}
		else goto _jmp_;
	case T_OptList :	{
		LVItem *itm=(LVItem *)it;
		int r;
		if(it && point.x() > columnWidth(0)){
			r=strcmp(itm->text(1), showY);
			itm->setType(r ? 0x206020<<8 : 0);
			itm->setText(1, r ? showY : showN);
			}
		}
		break; // return;
	case T_FspList :	
		filesor->stBar()->showMsg(NULL);
		goto _treeview_;
	case T_LnkTogList : // link-relate(pop-dialog)
	case T_PersonList :	// person
		break; // return;
	case T_FileList :
		setFocus();
		filesor->objsUpdate();
		filesor->imageInfo();
		goto _treeview_;
	case T_TreeView : if(((TreeView *)this)->testLost())return;
		if(it!=selectedItem())goto _treeview_;
		else if( (it=(LVItem *)selectedItem())!=NULL ){ // it(home), and mainlist = .xxx;  that dirNam != it(home)
			char *tmp;
			switch( M ){
			case _FASTTAGS : if(it==(LVItem *)firstChild()){
						if( e->button()==Qt::RightButton)filesor->getTagMenu()->exec(QCursor::pos());
						return;
						}
					tmp=((TreeView *)this)->tagFullPath(it);
					goto _jmp2_;
			case _PLACE : 
			case _OSROOT :
				tmp=treeFullPath(it);
			_jmp2_:	if(isHideDir(tmp)==NULL && strcmp(tmp, filesor->getDirNam()) ){
					((TreeView *)this)->setItemCurDir( it );
					if(M==_PLACE)((TreeView *)this)->selPart(it);
				}
				filesor->treeUpdateObjs(tmp);
				free(tmp);
			}
		}
_treeview_:	if( e->button()==Qt::RightButton){
			if(M==_FSPLUS&& Id!=1 )
				filesor->fspRightMenu(it, Id ); // Id==0 or 5
			else filesor->popRightMenu(it, /*filesor->dirId()!=winId()*/ Id==1 );
		}
		else  _jmp_:if ( it )pressMouse = true; 
	} // switch
    }
}

inline QStrList ListContent::getDirName(LVItem *item)
{
char *fnam=itemFullName(item);
QStrList lst;
lst.append(fnam);
free(fnam);
return lst;
}

void Filesan::showMountInfo(LVItem *it)
{
if(it && it->parent()==NULL){
  char txt[2000];
  FastBlock lst;
  lst.add(pdklst.lstIndex(listViewIndex((QListView *)treeview, it)), ",");
  int sz=atol(lst.lstIndex(4));
  if(sz>1024*1024){
	sprintf(txt, "%s => %s, Free: %.2f GB",
	lst.lstIndex(0), lst.lstIndex(lst.count()-1), ((float)sz)/(1024*1024) );
	}
  else {
	sprintf(txt, sz>1024 ? "%s => %s, Free: %u MB" : "%s => %s, Free: %u KB",
	lst.lstIndex(0), lst.lstIndex(lst.count()-1), sz>1024 ? sz/1024 : sz );
	}
  sbar->showMsg(txt , 90, 1, 0x000090 );
}
}

void ListContent::contentsMouseMoveEvent( QMouseEvent* e ) // mouse move every time to active
{
    if ( msgboxSignal==-1 && pressMouse && ( presspos - e->pos() ).manhattanLength() > QApplication::startDragDistance() ) {
	LVItem *item = (LVItem *)itemAt( contentsToViewport(presspos) );
	if( (Id==T_TreeView &&filesor->getModul()==_FASTTAGS) && item && item->parent()==NULL)return;
	pressMouse = false;
	msgboxSignal=0;
	itemCanDrop=true;
	if ( item ) {
	    QStrList slist( Id==T_TreeView ?  getDirName(item) :
		(Id==T_SearchList ? ((SearchModify *)topLevelWidget())->getFSels()->cvtQStrList() : filesor->getFSels()->cvtQStrList()) );
	    if(slist.count()>0){
		QUriDrag *ud= new QUriDrag( slist, viewport());
		oldItem=item;
		ud->setPixmap(*item->pixmap(0));
		ud->drag();
		itemCanDrop=true;
		oldItem=NULL;
// follow is : contentsDragEnterEvent, contentsDragMoveEvent, contentsDropEvent
// contentsDragLeaveEvent 是脱离原起动drag的（大）容器 (out)
		endTimer();
	    }
	}
   }
   else if(Id==T_TreeView&&filesor->getModul()==_PLACE){
	filesor->showMountInfo((LVItem *)itemAt( contentsToViewport(e->pos()) ));
	}
}

void ListContent::contentsMouseReleaseEvent( QMouseEvent *e )
{
    pressMouse = false;
    msgboxSignal=0;
    itemCanDrop=true;
}

void ListContent::contentsDragEnterEvent( QDragEnterEvent *e ) // 拖放始
{
dropMeet=NULL;	
stayItem=NULL;
}

void ListContent::contentsDragLeaveEvent( QDragLeaveEvent *e ) // 脱离原起动drag的器 (out)
{
endTimer();
if(stayItem)
	stayItem->setPixmap(0, *drgpix);
}

bool ListContent::isTagsRoot(LVItem *it)
{
return Id==T_TreeView && filesor->getModul()==_FASTTAGS &&
		it && it->parent()==NULL ;
}

bool canDrop(QMimeSource *e, const char *dst)
{
  QStrList lst;
  QUriDrag::decode( e, lst );
  if(lst.count()==1){
	int L=strlen(lst.at(0));
	if( strstr(dst, lst.at(0))==dst && (dst[L]=='/'||dst[L]==0) ) // isSelf(_dst,src)
		return false;
  }
  return true;
}

bool canBeDrop(QMimeSource *e, const char *dst)
{
  QStrList lst;
  QUriDrag::decode( e, lst );
  const char *ptr, *idx;
  int i, L;
  for( i=0; i<lst.count(); i++){
	ptr=lst.at(i);
	L=strlen(ptr);
	idx=strrchr(ptr, '/');
	if( strstr(dst, ptr)==dst && (dst[L]=='/'||dst[L]==0) ||
	strstr(ptr,dst)==ptr&&idx==ptr+strlen(dst) )return false;
	}
  return true;
}

void ListContent::contentsDragMoveEvent( QDragMoveEvent *e )
{
QPoint point=contentsToViewport( e->pos() );
LVItem *it = point.x()<columnWidth(0) ? (LVItem *)itemAt( point ) : NULL; // QDragMoveEvent bak(*e);
if(Id==T_FileList && (copyAction=e->action())!=QDropEvent::Copy
	&& canDrop(e, filesor->getDirNam())==false )goto _ign_;
if(Id==T_TreeView && it){
  char *pt;
  if(filesor->getModul()!=_FASTTAGS)pt=treeFullPath(it);
  else {
	if(it==firstChild())goto _skip_;
	pt=((TreeView *)this)->tagFullPath(it);
	}
  bool  b=canBeDrop(e, pt);
  free(pt);
  if(b==false)goto _ign_;
}
_skip_: if ( it  || Id==T_FileList ){
	if(dropTim==0)dropTim=startTimer(80);
	if(dropMeet != it){
		dropMeet=it;
		tms=0;
		if(isTagsRoot(it)){
			itemCanDrop=true;
			goto _jmp_;
			}
		adjDrop(it);
		if(itemCanDrop==false)goto _ign_;
	}
	else {
		if( it==NULL && Id==T_FileList)
			itemCanDrop=((filesor->getCDM()&(mode_w|mode_x))==(mode_w|mode_x));
		if(itemCanDrop==false)goto _ign_;
		}
_jmp_:	if(dropMeet!=stayItem && stayItem){
		stayItem->setPixmap(0, *drgpix); 	stayItem=NULL;
	}
	e->acceptAction();
	}
else {
_ign_:	endTimer();
	e->ignore();
	e->acceptAction(false);
	if(stayItem)stayItem->setPixmap(0, *drgpix);
	stayItem=NULL;
	}
}

void ListContent::contentsDropEvent( QDropEvent *e )
{
    char *dst;
    LVItem *item = (LVItem *)itemAt( contentsToViewport(e->pos()) );
    endTimer();
    if(oldItem && item==oldItem){ // self
	if(stayItem)stayItem->setPixmap(0, *drgpix);
	goto _ex_;
	}
    if(isTagsRoot(item)){
	int i;
	QStrList lst;
	struct stat64 st;
	QUriDrag::decode/*LocalFiles*/( e, lst );
	if(lst.count()>0)
	    for( i=0; i<lst.count(); i++){
		  if(stat64(lst.at(i), &st)==0 && S_ISDIR(st.st_mode))
			filesor->addTag( lst.at(i) );
		  else {
			char *msg=catstr(lst.at(i), notAsTag,32);
			filesor->stBar()->showMsg(msg, 50, 1, 0xa62018);
			free(msg);
		  }
		}
	e->accept();
	goto _skp_;
	}

    if ( item && item==stayItem ) {
	dst=itemFullName(item);
	_doCp_:	procDrop(topLevelWidget(), filesor, e,  dst);
	if(dst!=filesor->getDirNam()&&Id!=T_SearchList)free(dst);
_skp_:	if(stayItem)stayItem->setPixmap(0, *drgpix);
    }
    else {
	if( Id==T_FileList && stayItem==NULL &&
		(e->action()==QDropEvent::Copy||oldItem==NULL) /*not start-listview */ ){
		endTimer();
		dst=filesor->getDirNam();
		goto _doCp_;
		}
	_ex_: e->ignore();
	}
}

char *ListContent::itemFullName(LVItem *item)
{
switch(Id){
case T_TreeView : return filesor->getModul()!=_FASTTAGS ? treeFullPath(item) : ((TreeView *)this)->tagFullPath(item);
case T_SearchList : return item->fnam;
}
return  filesor->itemFullPath(item);
}

void ListContent::endTimer()
{
if(dropTim)killTimer(dropTim);
tms=0;
dropTim=0;
// pressMouse = false; // popbox : noRight ...
}

int ListContent::adjDrop(LVItem *it)
{
if(it){
	struct stat64 st;
	int isHome;
	char *pt=itemFullName(it);
	if(stat64(pt, &st)){
		itemCanDrop=false;
		return 3;
		}
	isHome=strcmp(pt, home);
	if(Id!=T_SearchList)free(pt);
	itemCanDrop=( S_ISDIR(st.st_mode) && (filesor->operaState(&st)&(mode_w|mode_x))==(mode_w|mode_x) );
	if( itemCanDrop==false && Id==T_FileList && copyAction==QDropEvent::Copy && S_ISDIR(st.st_mode)==false ){
		itemCanDrop=true;
		return 2;
		}
	return isHome ? 1 : 0;
}
// if(Id!=T_SearchList)itemCanDrop=((filesor->getCDM()&(mode_w|mode_x))==(mode_w|mode_x)); no occurrence
return 1;
}

bool ListContent::event( QEvent *e )
{
switch( e->type() ){
case QEvent::Timer :
	if(lostId){
		killTimer(lostId);
		lostId=0;
		((TreeView *)this)->treeRemove(NULL/* is lostItem */); // remove lost dir
		break;
	//	return true;
		}
	if(oldItem!=dropMeet && stayItem!=dropMeet && ++tms>6 ){
		bool tagRoot;
		if(stayItem)stayItem->setPixmap(0, *drgpix);
		stayItem=dropMeet;
		if(stayItem){
			int H;
			if( (tagRoot=isTagsRoot(stayItem)) )goto _jmp3_;
			H=adjDrop(stayItem);
			if( itemCanDrop && H<2 ){
		_jmp3_:		if(drgpix)*drgpix=*stayItem->pixmap(0);
				else drgpix=new QPixmap(*stayItem->pixmap(0));
				if(tagRoot){
				 	stayItem->setPixmap(0, *pixmapLoad(tagMvAddImg));
					filesor->stBar()->showMsg(willCreateTag, 50);
					}
				else stayItem->setPixmap(0, *pixmapLoad(H==0 ? homeOpenImg : 
					(Id==0&&filesor->getModul()==_PLACE&&stayItem->parent()==NULL ? diskDragImg : dirOpenImg)) );
				}
			else stayItem=NULL;
		}
	}
	break;
case QEvent::KeyPress :
	if( /*strcmp(name(), OptListChs)==0 */ Id==T_OptList){
		QListViewItem *itm=currentItem();
		int k=((QKeyEvent *)e)->key();
		switch(k){
		case Key_Space : itm->setText(1, strcmp(itm->text(1), showY)? showY : showN);
			break;
		case Key_N :
		case Key_Y : char buf[2];
			buf[0]=k;	buf[1]=0;
			itm->setText(1, buf);
		}
		}
		break;
case QEvent::FocusIn :	switch(Id){
			case T_TreeView :
				char *tmp;
				LVItem *it;
				it=(LVItem *)currentItem();
				switch(filesor->getModul()){
				case _FASTTAGS : tmp=((TreeView *)this)->tagFullPath(it);
					goto _jmp_;
				case _PLACE : 
				case _OSROOT : tmp=treeFullPath(it);
				_jmp_:  if(tmp){
					filesor->treeUpdateObjs(tmp);
					free(tmp);
					}
				  else filesor->setObjsStat(0, false);
				}
				break;
			case T_FileList : filesor->objsUpdate();
			}
//	break;
/*case QEvent::FocusOut : if(vDir==winId() && filesor->modVal()==1 ){
			TreeView *tv=(TreeView *)this;
			disconnect(tv, sig_dSelChange, filesor, slot_dSelChange );
			clearSelection();
			connect(tv, sig_dSelChange, filesor, slot_dSelChange );
			}*/
}
return QListView::event(e);
}

void ListContent::selectedCollect(FastBlock *sels, StatusPanel *sbar)
{
  LVItem  *curIt;
  if( (curIt=(LVItem *)currentItem()) ){
  struct stat64 st;
  char *pt;
  int idx;
  LVItem *item=(LVItem *)firstChild();
  sels->setIndex(0);
   while( item ){
	if( isSelected(item) /*&& item->fnam*/ ){
	  pt = Id!=T_SearchList ? filesor->itemFullPath(item) : item->fnam;
	  switch( isExist(pt, &st) ){
//	  case none_File : goto _jmp_; //  item=(LVItem *)item->nextSibling();	if(!isSearch)free(pt);	  continue;
	  case lost_Link : if( curIt==item )showLink(sbar, lnkNone,pt, 0xe03b0a);
		break;
	  case symLink : if( curIt==item )showLink(sbar, linkAs, pt, 0x208020);
	  }
	  idx=sels->add(  pt );
	  if( curIt==item )sels->setIndex(idx);
	  if(Id!=T_SearchList)free(pt);
	}
	item=(LVItem *)item->nextSibling();
      }
sels->memDiv(NULL);
  }
}


LVItem  * ListContent::curSelItem()
{
LVItem *selIt=NULL, *curIt;
if( (curIt=(LVItem *)currentItem()) ){
   LVItem  *item=(LVItem *)firstChild();
   while( item ){
	if( isSelected(item) ){
		selIt=item;
		if(curIt==item)return item;
	}
	item=(LVItem *)item->nextSibling();
   }
}
return selIt ? selIt : curIt;
}
