/*
	林江华(xempo)编写，2010-2，Copyright LinJiangHua
	Free under LGPL
*/

#ifndef    TREE_VIEW
#define    TREE_VIEW

#include "listcontent.h"
#include "fspdir.h"

enum MultPanel_Mode { _OSROOT, _PLACE, _FASTTAGS, _FSPLUS, NO_MULT_PANEL };

class QTimer;

class TreeView : public ListContent
{
 moc_Object
public :
TreeView(QWidget *wdg, int id, Filesan *fs);
// ~TreeView();
// int Init(const char *dnam);
LVItem *seekDir(const char *path, int sw, const char *dst=NULL);
void dirExpanding(LVItem *);

int setItemCurDir(LVItem *it);

LVItem *newDirItem(const char *nam, const QPixmap *pix, int est ); /* est 是否exist item, 0 create, 1 exist */

void treeRemove(LVItem *);
void treeDel(LVItem *);

void treeSort(int Msg);
void sortTagsItem();

void updateParts();
void selPart(LVItem *it, char *dat=NULL, int i=0);
char *tagFullPath(LVItem *);
void createTags();
void creatTagItem(int i, int sort);
void createFsplus(bool init);

fsp_dir *testFspDir(LVItem *it);

fsp_dir *getFspDir() const
{ return fspDir; }

void setFsp(fsp_lib *fsp){ fspLib=fsp; }

void setFspDir(fsp_dir *dir){ fspDir=dir; }

void setRecent(fsp_lib *lib){ recentFsp=lib; }

fsp_dir *itemFspDir(LVItem *it);
fsp_lib *itemFspRoot(LVItem *it);

void freshItem(LVItem *it, fsp_dir *dir, bool sub);

fsp_dir * selFspDir(LVItem *it, fsp_dir *pdir, int msg);

LVItem *seekFspDir(fsp_lib *fsp, const char *path, int msg);

LVItem *deelFspDir(fsp_dir *dir, int msg);

void chFspDir(LVItem *it);

inline bool testLost(); // listcontent.cpp

void selectFspDir()
{
setSelected(fspSel ? fspSel : (LVItem *)currentItem(), true);
}

private :
LVItem *selDir, *fspSel,
	*fsRootItem, *lostItem;
void takeFS();
void exeMount(const char *pt);

int *_Params;
bool lostTag, Subpd_creat, seekDirMsg,
	skpslot;

QTimer *dirLostTimer;

fsp_dir *fspDir;
fsp_lib *fspLib, *recentFsp;
void treeLostDel(LVItem *it);
int setTreeDir(LVItem *dirIt, int tag); //return: 0正确, 否则 enum FILE_TEST { }
void sortSub();

LVItem *sortItem(LVItem *it, int sort, const char *nam);

};

extern void doMount(FastBlock *lst);
extern void getMount(FastBlock *lst, FastBlock &tmp);
extern int listViewIndex(QListView *lvw, LVItem *it);
extern bool isMount(const char *dnam);

extern int _selFspNum(fsp_dir *pdir, BYTE *unit); // fsptree.cpp

extern void removeLeft(LVItem *it);

#define	testRemoveDir(fnam)		seekDir(fnam, TEST_REMOVE_DIR)
#define	removeDir(fnam)		seekDir(fnam, REMOVE_DIR)

extern const char  slot_doRen[],	sig_doRen[],
	sig_enter[],
	sig_expand[], slot_expand[];

#endif
